#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, Flash ROM data"]
    pub r32_flash_data: R32_FLASH_DATA,
    #[doc = "0x04 - RW, Flash ROM address"]
    pub r32_flash_addr: R32_FLASH_ADDR,
    #[doc = "0x08 - WO, Flash ROM operation command"]
    pub r8_flash_command: R8_FLASH_COMMAND,
    #[doc = "0x09 - RW, Flash ROM protect control"]
    pub r8_flash_protect: R8_FLASH_PROTECT,
    #[doc = "0x0a - RO, Flash ROM operation status"]
    pub r16_flash_status: R16_FLASH_STATUS,
}
#[doc = "R32_FLASH_DATA (rw) register accessor: an alias for `Reg<R32_FLASH_DATA_SPEC>`"]
pub type R32_FLASH_DATA = crate::Reg<r32_flash_data::R32_FLASH_DATA_SPEC>;
#[doc = "RW, Flash ROM data"]
pub mod r32_flash_data;
#[doc = "R32_FLASH_ADDR (rw) register accessor: an alias for `Reg<R32_FLASH_ADDR_SPEC>`"]
pub type R32_FLASH_ADDR = crate::Reg<r32_flash_addr::R32_FLASH_ADDR_SPEC>;
#[doc = "RW, Flash ROM address"]
pub mod r32_flash_addr;
#[doc = "R8_FLASH_COMMAND (w) register accessor: an alias for `Reg<R8_FLASH_COMMAND_SPEC>`"]
pub type R8_FLASH_COMMAND = crate::Reg<r8_flash_command::R8_FLASH_COMMAND_SPEC>;
#[doc = "WO, Flash ROM operation command"]
pub mod r8_flash_command;
#[doc = "R8_FLASH_PROTECT (rw) register accessor: an alias for `Reg<R8_FLASH_PROTECT_SPEC>`"]
pub type R8_FLASH_PROTECT = crate::Reg<r8_flash_protect::R8_FLASH_PROTECT_SPEC>;
#[doc = "RW, Flash ROM protect control"]
pub mod r8_flash_protect;
#[doc = "R16_FLASH_STATUS (r) register accessor: an alias for `Reg<R16_FLASH_STATUS_SPEC>`"]
pub type R16_FLASH_STATUS = crate::Reg<r16_flash_status::R16_FLASH_STATUS_SPEC>;
#[doc = "RO, Flash ROM operation status"]
pub mod r16_flash_status;
