#[doc = "Register `R16_FLASH_STATUS` reader"]
pub struct R(crate::R<R16_FLASH_STATUS_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R16_FLASH_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R16_FLASH_STATUS_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R16_FLASH_STATUS_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Field `RB_ROM_CMD_TOUT` reader - RO, Flash ROM operation result: 0=success, 1=operation time out"]
pub type RB_ROM_CMD_TOUT_R = crate::BitReader<bool>;
#[doc = "Field `RB_ROM_CMD_ERR` reader - RO, Flash ROM operation command error flag: 0=command accepted, 1=unknown command"]
pub type RB_ROM_CMD_ERR_R = crate::BitReader<bool>;
#[doc = "Field `RB_ROM_ADDR_OK` reader - RO, Flash ROM erase/write operation address valid flag, can be reviewed before or after operation: 0=invalid parameter, 1=address valid"]
pub type RB_ROM_ADDR_OK_R = crate::BitReader<bool>;
#[doc = "Field `RB_ROM_READ_FREE` reader - RO, indicate protected status of Flash ROM code and data: 0=reading protect, 1=enable read by external programmer"]
pub type RB_ROM_READ_FREE_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 0 - RO, Flash ROM operation result: 0=success, 1=operation time out"]
    #[inline(always)]
    pub fn rb_rom_cmd_tout(&self) -> RB_ROM_CMD_TOUT_R {
        RB_ROM_CMD_TOUT_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RO, Flash ROM operation command error flag: 0=command accepted, 1=unknown command"]
    #[inline(always)]
    pub fn rb_rom_cmd_err(&self) -> RB_ROM_CMD_ERR_R {
        RB_ROM_CMD_ERR_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 6 - RO, Flash ROM erase/write operation address valid flag, can be reviewed before or after operation: 0=invalid parameter, 1=address valid"]
    #[inline(always)]
    pub fn rb_rom_addr_ok(&self) -> RB_ROM_ADDR_OK_R {
        RB_ROM_ADDR_OK_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 8 - RO, indicate protected status of Flash ROM code and data: 0=reading protect, 1=enable read by external programmer"]
    #[inline(always)]
    pub fn rb_rom_read_free(&self) -> RB_ROM_READ_FREE_R {
        RB_ROM_READ_FREE_R::new(((self.bits >> 8) & 1) != 0)
    }
}
#[doc = "RO, Flash ROM operation status\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r16_flash_status](index.html) module"]
pub struct R16_FLASH_STATUS_SPEC;
impl crate::RegisterSpec for R16_FLASH_STATUS_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [r16_flash_status::R](R) reader structure"]
impl crate::Readable for R16_FLASH_STATUS_SPEC {
    type Reader = R;
}
#[doc = "`reset()` method sets R16_FLASH_STATUS to value 0"]
impl crate::Resettable for R16_FLASH_STATUS_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
