#[doc = "Register `R8_FLASH_PROTECT` reader"]
pub struct R(crate::R<R8_FLASH_PROTECT_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_FLASH_PROTECT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_FLASH_PROTECT_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_FLASH_PROTECT_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_FLASH_PROTECT` writer"]
pub struct W(crate::W<R8_FLASH_PROTECT_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_FLASH_PROTECT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_FLASH_PROTECT_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_FLASH_PROTECT_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_ROM_DATA_WE` reader - RW, enable Flash ROM data area being erase/write: 0=writing protect, 1=enable program and erase"]
pub type RB_ROM_DATA_WE_R = crate::BitReader<bool>;
#[doc = "Field `RB_ROM_DATA_WE` writer - RW, enable Flash ROM data area being erase/write: 0=writing protect, 1=enable program and erase"]
pub type RB_ROM_DATA_WE_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_FLASH_PROTECT_SPEC, bool, O>;
#[doc = "Field `RB_ROM_CODE_WE` reader - RW, enable Flash ROM code area being erase/write: 0=writing protect, 1=enable program and erase"]
pub type RB_ROM_CODE_WE_R = crate::BitReader<bool>;
#[doc = "Field `RB_ROM_CODE_WE` writer - RW, enable Flash ROM code area being erase/write: 0=writing protect, 1=enable program and erase"]
pub type RB_ROM_CODE_WE_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_FLASH_PROTECT_SPEC, bool, O>;
#[doc = "Field `RB_ROM_WE_MUST_10` writer - RW, must write 10"]
pub type RB_ROM_WE_MUST_10_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_FLASH_PROTECT_SPEC, u8, u8, 2, O>;
impl R {
    #[doc = "Bit 2 - RW, enable Flash ROM data area being erase/write: 0=writing protect, 1=enable program and erase"]
    #[inline(always)]
    pub fn rb_rom_data_we(&self) -> RB_ROM_DATA_WE_R {
        RB_ROM_DATA_WE_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, enable Flash ROM code area being erase/write: 0=writing protect, 1=enable program and erase"]
    #[inline(always)]
    pub fn rb_rom_code_we(&self) -> RB_ROM_CODE_WE_R {
        RB_ROM_CODE_WE_R::new(((self.bits >> 3) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 2 - RW, enable Flash ROM data area being erase/write: 0=writing protect, 1=enable program and erase"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rom_data_we(&mut self) -> RB_ROM_DATA_WE_W<2> {
        RB_ROM_DATA_WE_W::new(self)
    }
    #[doc = "Bit 3 - RW, enable Flash ROM code area being erase/write: 0=writing protect, 1=enable program and erase"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rom_code_we(&mut self) -> RB_ROM_CODE_WE_W<3> {
        RB_ROM_CODE_WE_W::new(self)
    }
    #[doc = "Bits 6:7 - RW, must write 10"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rom_we_must_10(&mut self) -> RB_ROM_WE_MUST_10_W<6> {
        RB_ROM_WE_MUST_10_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, Flash ROM protect control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_flash_protect](index.html) module"]
pub struct R8_FLASH_PROTECT_SPEC;
impl crate::RegisterSpec for R8_FLASH_PROTECT_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_flash_protect::R](R) reader structure"]
impl crate::Readable for R8_FLASH_PROTECT_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_flash_protect::W](W) writer structure"]
impl crate::Writable for R8_FLASH_PROTECT_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_FLASH_PROTECT to value 0"]
impl crate::Resettable for R8_FLASH_PROTECT_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
