#[doc = "Register `R8_LCD_CTRL_MOD` reader"]
pub struct R(crate::R<R8_LCD_CTRL_MOD_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_LCD_CTRL_MOD_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_LCD_CTRL_MOD_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_LCD_CTRL_MOD_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_LCD_CTRL_MOD` writer"]
pub struct W(crate::W<R8_LCD_CTRL_MOD_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_LCD_CTRL_MOD_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_LCD_CTRL_MOD_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_LCD_CTRL_MOD_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_SYS_POWER_ON` reader - RW, LCD digital system enable"]
pub type RB_SYS_POWER_ON_R = crate::BitReader<bool>;
#[doc = "Field `RB_SYS_POWER_ON` writer - RW, LCD digital system enable"]
pub type RB_SYS_POWER_ON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LCD_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LCD_POWER_ON` reader - RW, LCD analog system enable"]
pub type RB_LCD_POWER_ON_R = crate::BitReader<bool>;
#[doc = "Field `RB_LCD_POWER_ON` writer - RW, LCD analog system enable"]
pub type RB_LCD_POWER_ON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LCD_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LCD_BIAS` reader - RW, LCD bias select: 0=1/2 bias, 1=1/3 bias"]
pub type RB_LCD_BIAS_R = crate::BitReader<bool>;
#[doc = "Field `RB_LCD_BIAS` writer - RW, LCD bias select: 0=1/2 bias, 1=1/3 bias"]
pub type RB_LCD_BIAS_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_LCD_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LCD_DUTY` reader - RW, LCD duty select: 00=1/2 duty, 01=1/3 duty, 10=1/4 duty"]
pub type RB_LCD_DUTY_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_LCD_DUTY` writer - RW, LCD duty select: 00=1/2 duty, 01=1/3 duty, 10=1/4 duty"]
pub type RB_LCD_DUTY_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_LCD_CTRL_MOD_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_LCD_SCAN_CLK` reader - RW, LCD scan clock select: 00=256Hz, 01=512Hz, 10=1KHz, 11=128Hz"]
pub type RB_LCD_SCAN_CLK_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_LCD_SCAN_CLK` writer - RW, LCD scan clock select: 00=256Hz, 01=512Hz, 10=1KHz, 11=128Hz"]
pub type RB_LCD_SCAN_CLK_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_LCD_CTRL_MOD_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_LCD_V_SEL` reader - RW, LCD drive voltage:0=VIO33*100%(3.3V),1=VIO33*76%(2.5V)"]
pub type RB_LCD_V_SEL_R = crate::BitReader<bool>;
#[doc = "Field `RB_LCD_V_SEL` writer - RW, LCD drive voltage:0=VIO33*100%(3.3V),1=VIO33*76%(2.5V)"]
pub type RB_LCD_V_SEL_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_LCD_CTRL_MOD_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, LCD digital system enable"]
    #[inline(always)]
    pub fn rb_sys_power_on(&self) -> RB_SYS_POWER_ON_R {
        RB_SYS_POWER_ON_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, LCD analog system enable"]
    #[inline(always)]
    pub fn rb_lcd_power_on(&self) -> RB_LCD_POWER_ON_R {
        RB_LCD_POWER_ON_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, LCD bias select: 0=1/2 bias, 1=1/3 bias"]
    #[inline(always)]
    pub fn rb_lcd_bias(&self) -> RB_LCD_BIAS_R {
        RB_LCD_BIAS_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bits 3:4 - RW, LCD duty select: 00=1/2 duty, 01=1/3 duty, 10=1/4 duty"]
    #[inline(always)]
    pub fn rb_lcd_duty(&self) -> RB_LCD_DUTY_R {
        RB_LCD_DUTY_R::new((self.bits >> 3) & 3)
    }
    #[doc = "Bits 5:6 - RW, LCD scan clock select: 00=256Hz, 01=512Hz, 10=1KHz, 11=128Hz"]
    #[inline(always)]
    pub fn rb_lcd_scan_clk(&self) -> RB_LCD_SCAN_CLK_R {
        RB_LCD_SCAN_CLK_R::new((self.bits >> 5) & 3)
    }
    #[doc = "Bit 7 - RW, LCD drive voltage:0=VIO33*100%(3.3V),1=VIO33*76%(2.5V)"]
    #[inline(always)]
    pub fn rb_lcd_v_sel(&self) -> RB_LCD_V_SEL_R {
        RB_LCD_V_SEL_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, LCD digital system enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_sys_power_on(&mut self) -> RB_SYS_POWER_ON_W<0> {
        RB_SYS_POWER_ON_W::new(self)
    }
    #[doc = "Bit 1 - RW, LCD analog system enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_lcd_power_on(&mut self) -> RB_LCD_POWER_ON_W<1> {
        RB_LCD_POWER_ON_W::new(self)
    }
    #[doc = "Bit 2 - RW, LCD bias select: 0=1/2 bias, 1=1/3 bias"]
    #[inline(always)]
    #[must_use]
    pub fn rb_lcd_bias(&mut self) -> RB_LCD_BIAS_W<2> {
        RB_LCD_BIAS_W::new(self)
    }
    #[doc = "Bits 3:4 - RW, LCD duty select: 00=1/2 duty, 01=1/3 duty, 10=1/4 duty"]
    #[inline(always)]
    #[must_use]
    pub fn rb_lcd_duty(&mut self) -> RB_LCD_DUTY_W<3> {
        RB_LCD_DUTY_W::new(self)
    }
    #[doc = "Bits 5:6 - RW, LCD scan clock select: 00=256Hz, 01=512Hz, 10=1KHz, 11=128Hz"]
    #[inline(always)]
    #[must_use]
    pub fn rb_lcd_scan_clk(&mut self) -> RB_LCD_SCAN_CLK_W<5> {
        RB_LCD_SCAN_CLK_W::new(self)
    }
    #[doc = "Bit 7 - RW, LCD drive voltage:0=VIO33*100%(3.3V),1=VIO33*76%(2.5V)"]
    #[inline(always)]
    #[must_use]
    pub fn rb_lcd_v_sel(&mut self) -> RB_LCD_V_SEL_W<7> {
        RB_LCD_V_SEL_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "R8_LCD_CTRL_MOD\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_lcd_ctrl_mod](index.html) module"]
pub struct R8_LCD_CTRL_MOD_SPEC;
impl crate::RegisterSpec for R8_LCD_CTRL_MOD_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_lcd_ctrl_mod::R](R) reader structure"]
impl crate::Readable for R8_LCD_CTRL_MOD_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_lcd_ctrl_mod::W](W) writer structure"]
impl crate::Writable for R8_LCD_CTRL_MOD_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_LCD_CTRL_MOD to value 0"]
impl crate::Resettable for R8_LCD_CTRL_MOD_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
