#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, LED mode control"]
    pub r8_led_ctrl_mod: R8_LED_CTRL_MOD,
    #[doc = "0x01 - RW, LED serial clock divisor"]
    pub r8_led_clock_div: R8_LED_CLOCK_DIV,
    _reserved2: [u8; 0x02],
    #[doc = "0x04 - RO, LED status"]
    pub r8_led_status: R8_LED_STATUS,
    _reserved3: [u8; 0x03],
    #[doc = "0x08 - WO, LED FIFO register, width is half-word"]
    pub r16_led_fifo: R16_LED_FIFO,
    _reserved4: [u8; 0x06],
    #[doc = "0x10 - RW, LED DMA main buffer remainder half-word count, exclude auxiliary buffer, automatic decreasing after DMA, only low 12 bit"]
    pub r16_led_dma_cnt: R16_LED_DMA_CNT,
    _reserved5: [u8; 0x02],
    #[doc = "0x14 - RW, LED main buffer DMA begin and current address, automatic increasing after DMA"]
    pub r16_led_dma_main: R16_LED_DMA_MAIN,
    _reserved6: [u8; 0x02],
    #[doc = "0x18 - RW, LED auxiliary buffer DMA begin and current address, automatic increasing after DMA"]
    pub r16_led_dma_aux: R16_LED_DMA_AUX,
}
#[doc = "R8_LED_CTRL_MOD (rw) register accessor: an alias for `Reg<R8_LED_CTRL_MOD_SPEC>`"]
pub type R8_LED_CTRL_MOD = crate::Reg<r8_led_ctrl_mod::R8_LED_CTRL_MOD_SPEC>;
#[doc = "RW, LED mode control"]
pub mod r8_led_ctrl_mod;
#[doc = "R8_LED_CLOCK_DIV (rw) register accessor: an alias for `Reg<R8_LED_CLOCK_DIV_SPEC>`"]
pub type R8_LED_CLOCK_DIV = crate::Reg<r8_led_clock_div::R8_LED_CLOCK_DIV_SPEC>;
#[doc = "RW, LED serial clock divisor"]
pub mod r8_led_clock_div;
#[doc = "R8_LED_STATUS (rw) register accessor: an alias for `Reg<R8_LED_STATUS_SPEC>`"]
pub type R8_LED_STATUS = crate::Reg<r8_led_status::R8_LED_STATUS_SPEC>;
#[doc = "RO, LED status"]
pub mod r8_led_status;
#[doc = "R16_LED_FIFO (w) register accessor: an alias for `Reg<R16_LED_FIFO_SPEC>`"]
pub type R16_LED_FIFO = crate::Reg<r16_led_fifo::R16_LED_FIFO_SPEC>;
#[doc = "WO, LED FIFO register, width is half-word"]
pub mod r16_led_fifo;
#[doc = "R16_LED_DMA_CNT (rw) register accessor: an alias for `Reg<R16_LED_DMA_CNT_SPEC>`"]
pub type R16_LED_DMA_CNT = crate::Reg<r16_led_dma_cnt::R16_LED_DMA_CNT_SPEC>;
#[doc = "RW, LED DMA main buffer remainder half-word count, exclude auxiliary buffer, automatic decreasing after DMA, only low 12 bit"]
pub mod r16_led_dma_cnt;
#[doc = "R16_LED_DMA_MAIN (rw) register accessor: an alias for `Reg<R16_LED_DMA_MAIN_SPEC>`"]
pub type R16_LED_DMA_MAIN = crate::Reg<r16_led_dma_main::R16_LED_DMA_MAIN_SPEC>;
#[doc = "RW, LED main buffer DMA begin and current address, automatic increasing after DMA"]
pub mod r16_led_dma_main;
#[doc = "R16_LED_DMA_AUX (rw) register accessor: an alias for `Reg<R16_LED_DMA_AUX_SPEC>`"]
pub type R16_LED_DMA_AUX = crate::Reg<r16_led_dma_aux::R16_LED_DMA_AUX_SPEC>;
#[doc = "RW, LED auxiliary buffer DMA begin and current address, automatic increasing after DMA"]
pub mod r16_led_dma_aux;
