#[doc = "Register `R8_LED_CTRL_MOD` reader"]
pub struct R(crate::R<R8_LED_CTRL_MOD_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_LED_CTRL_MOD_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_LED_CTRL_MOD_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_LED_CTRL_MOD_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_LED_CTRL_MOD` writer"]
pub struct W(crate::W<R8_LED_CTRL_MOD_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_LED_CTRL_MOD_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_LED_CTRL_MOD_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_LED_CTRL_MOD_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_LED_BIT_ORDER` reader - RW, LED bit data order: 0=LSB first, 1=MSB first"]
pub type RB_LED_BIT_ORDER_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_BIT_ORDER` writer - RW, LED bit data order: 0=LSB first, 1=MSB first"]
pub type RB_LED_BIT_ORDER_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LED_ALL_CLEAR` reader - RW, force clear LED FIFO and count"]
pub type RB_LED_ALL_CLEAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_ALL_CLEAR` writer - RW, force clear LED FIFO and count"]
pub type RB_LED_ALL_CLEAR_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LED_OUT_POLAR` reader - RW, LED output polarity: 0=pass, 1=invert"]
pub type RB_LED_OUT_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_OUT_POLAR` writer - RW, LED output polarity: 0=pass, 1=invert"]
pub type RB_LED_OUT_POLAR_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LED_OUT_EN` reader - RW, LED output enable"]
pub type RB_LED_OUT_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_OUT_EN` writer - RW, LED output enable"]
pub type RB_LED_OUT_EN_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LED_DMA_EN` reader - RW, LED DMA enable and DMA interrupt enable"]
pub type RB_LED_DMA_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_DMA_EN` writer - RW, LED DMA enable and DMA interrupt enable"]
pub type RB_LED_DMA_EN_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LED_IE_FIFO` reader - RW, enable interrupt for LED FIFO less than 2"]
pub type RB_LED_IE_FIFO_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_IE_FIFO` writer - RW, enable interrupt for LED FIFO less than 2"]
pub type RB_LED_IE_FIFO_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, bool, O>;
#[doc = "Field `RB_LED_CHAN_MOD` reader - RW, LED channel mode: 00=LED0, 01=LED0/1, 10=LED0~3, 11=LED0~3 and LED2/3 from auxiliary buffer"]
pub type RB_LED_CHAN_MOD_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_LED_CHAN_MOD` writer - RW, LED channel mode: 00=LED0, 01=LED0/1, 10=LED0~3, 11=LED0~3 and LED2/3 from auxiliary buffer"]
pub type RB_LED_CHAN_MOD_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_LED_CTRL_MOD_SPEC, u8, u8, 2, O>;
impl R {
    #[doc = "Bit 0 - RW, LED bit data order: 0=LSB first, 1=MSB first"]
    #[inline(always)]
    pub fn rb_led_bit_order(&self) -> RB_LED_BIT_ORDER_R {
        RB_LED_BIT_ORDER_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, force clear LED FIFO and count"]
    #[inline(always)]
    pub fn rb_led_all_clear(&self) -> RB_LED_ALL_CLEAR_R {
        RB_LED_ALL_CLEAR_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, LED output polarity: 0=pass, 1=invert"]
    #[inline(always)]
    pub fn rb_led_out_polar(&self) -> RB_LED_OUT_POLAR_R {
        RB_LED_OUT_POLAR_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, LED output enable"]
    #[inline(always)]
    pub fn rb_led_out_en(&self) -> RB_LED_OUT_EN_R {
        RB_LED_OUT_EN_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RW, LED DMA enable and DMA interrupt enable"]
    #[inline(always)]
    pub fn rb_led_dma_en(&self) -> RB_LED_DMA_EN_R {
        RB_LED_DMA_EN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW, enable interrupt for LED FIFO less than 2"]
    #[inline(always)]
    pub fn rb_led_ie_fifo(&self) -> RB_LED_IE_FIFO_R {
        RB_LED_IE_FIFO_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bits 6:7 - RW, LED channel mode: 00=LED0, 01=LED0/1, 10=LED0~3, 11=LED0~3 and LED2/3 from auxiliary buffer"]
    #[inline(always)]
    pub fn rb_led_chan_mod(&self) -> RB_LED_CHAN_MOD_R {
        RB_LED_CHAN_MOD_R::new((self.bits >> 6) & 3)
    }
}
impl W {
    #[doc = "Bit 0 - RW, LED bit data order: 0=LSB first, 1=MSB first"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_bit_order(&mut self) -> RB_LED_BIT_ORDER_W<0> {
        RB_LED_BIT_ORDER_W::new(self)
    }
    #[doc = "Bit 1 - RW, force clear LED FIFO and count"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_all_clear(&mut self) -> RB_LED_ALL_CLEAR_W<1> {
        RB_LED_ALL_CLEAR_W::new(self)
    }
    #[doc = "Bit 2 - RW, LED output polarity: 0=pass, 1=invert"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_out_polar(&mut self) -> RB_LED_OUT_POLAR_W<2> {
        RB_LED_OUT_POLAR_W::new(self)
    }
    #[doc = "Bit 3 - RW, LED output enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_out_en(&mut self) -> RB_LED_OUT_EN_W<3> {
        RB_LED_OUT_EN_W::new(self)
    }
    #[doc = "Bit 4 - RW, LED DMA enable and DMA interrupt enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_dma_en(&mut self) -> RB_LED_DMA_EN_W<4> {
        RB_LED_DMA_EN_W::new(self)
    }
    #[doc = "Bit 5 - RW, enable interrupt for LED FIFO less than 2"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_ie_fifo(&mut self) -> RB_LED_IE_FIFO_W<5> {
        RB_LED_IE_FIFO_W::new(self)
    }
    #[doc = "Bits 6:7 - RW, LED channel mode: 00=LED0, 01=LED0/1, 10=LED0~3, 11=LED0~3 and LED2/3 from auxiliary buffer"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_chan_mod(&mut self) -> RB_LED_CHAN_MOD_W<6> {
        RB_LED_CHAN_MOD_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, LED mode control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_led_ctrl_mod](index.html) module"]
pub struct R8_LED_CTRL_MOD_SPEC;
impl crate::RegisterSpec for R8_LED_CTRL_MOD_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_led_ctrl_mod::R](R) reader structure"]
impl crate::Readable for R8_LED_CTRL_MOD_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_led_ctrl_mod::W](W) writer structure"]
impl crate::Writable for R8_LED_CTRL_MOD_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_LED_CTRL_MOD to value 0"]
impl crate::Resettable for R8_LED_CTRL_MOD_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
