#[doc = "Register `R8_LED_STATUS` reader"]
pub struct R(crate::R<R8_LED_STATUS_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_LED_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_LED_STATUS_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_LED_STATUS_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_LED_STATUS` writer"]
pub struct W(crate::W<R8_LED_STATUS_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_LED_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_LED_STATUS_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_LED_STATUS_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_LED_FIFO_COUNT` reader - RO, LED FIFO byte count status, must divided by 2 for width half-word"]
pub type RB_LED_FIFO_COUNT_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_LED_CLOCK` reader - RO, current LED clock level"]
pub type RB_LED_CLOCK_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_IF_FIFO` reader - RW1, interrupt flag for LED FIFO less than 2, cleared by RW1 or write R32/R16_LED_FIFO"]
pub type RB_LED_IF_FIFO_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_IF_FIFO` writer - RW1, interrupt flag for LED FIFO less than 2, cleared by RW1 or write R32/R16_LED_FIFO"]
pub type RB_LED_IF_FIFO_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_LED_STATUS_SPEC, bool, O>;
#[doc = "Field `RB_LED_FIFO_EMPTY` reader - RO: indicate FIFO empty status"]
pub type RB_LED_FIFO_EMPTY_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_IF_DMA_END` reader - RW1, interrupt flag for LED DMA completion, cleared by RW1 or write R32/R16_LED_DMA_CNT"]
pub type RB_LED_IF_DMA_END_R = crate::BitReader<bool>;
#[doc = "Field `RB_LED_IF_DMA_END` writer - RW1, interrupt flag for LED DMA completion, cleared by RW1 or write R32/R16_LED_DMA_CNT"]
pub type RB_LED_IF_DMA_END_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_LED_STATUS_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:2 - RO, LED FIFO byte count status, must divided by 2 for width half-word"]
    #[inline(always)]
    pub fn rb_led_fifo_count(&self) -> RB_LED_FIFO_COUNT_R {
        RB_LED_FIFO_COUNT_R::new(self.bits & 7)
    }
    #[doc = "Bit 4 - RO, current LED clock level"]
    #[inline(always)]
    pub fn rb_led_clock(&self) -> RB_LED_CLOCK_R {
        RB_LED_CLOCK_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW1, interrupt flag for LED FIFO less than 2, cleared by RW1 or write R32/R16_LED_FIFO"]
    #[inline(always)]
    pub fn rb_led_if_fifo(&self) -> RB_LED_IF_FIFO_R {
        RB_LED_IF_FIFO_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RO: indicate FIFO empty status"]
    #[inline(always)]
    pub fn rb_led_fifo_empty(&self) -> RB_LED_FIFO_EMPTY_R {
        RB_LED_FIFO_EMPTY_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RW1, interrupt flag for LED DMA completion, cleared by RW1 or write R32/R16_LED_DMA_CNT"]
    #[inline(always)]
    pub fn rb_led_if_dma_end(&self) -> RB_LED_IF_DMA_END_R {
        RB_LED_IF_DMA_END_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 5 - RW1, interrupt flag for LED FIFO less than 2, cleared by RW1 or write R32/R16_LED_FIFO"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_if_fifo(&mut self) -> RB_LED_IF_FIFO_W<5> {
        RB_LED_IF_FIFO_W::new(self)
    }
    #[doc = "Bit 7 - RW1, interrupt flag for LED DMA completion, cleared by RW1 or write R32/R16_LED_DMA_CNT"]
    #[inline(always)]
    #[must_use]
    pub fn rb_led_if_dma_end(&mut self) -> RB_LED_IF_DMA_END_W<7> {
        RB_LED_IF_DMA_END_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RO, LED status\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_led_status](index.html) module"]
pub struct R8_LED_STATUS_SPEC;
impl crate::RegisterSpec for R8_LED_STATUS_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_led_status::R](R) reader structure"]
impl crate::Readable for R8_LED_STATUS_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_led_status::W](W) writer structure"]
impl crate::Writable for R8_LED_STATUS_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_LED_STATUS to value 0"]
impl crate::Resettable for R8_LED_STATUS_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
