#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, SPI0 mode control"]
    pub r8_spi0_ctrl_mod: R8_SPI0_CTRL_MOD,
    #[doc = "0x01 - RW, SPI0 configuration control"]
    pub r8_spi0_ctrl_cfg: R8_SPI0_CTRL_CFG,
    #[doc = "0x02 - RW, SPI0 interrupt enable"]
    pub r8_spi0_inter_en: R8_SPI0_INTER_EN,
    #[doc = "0x03 - RW, SPI0 master clock divisor;RW, SPI0 slave preset value"]
    pub r8_spi0_clock_div__r8_spi0_slave_pre: R8_SPI0_CLOCK_DIV__R8_SPI0_SLAVE_PRE,
    #[doc = "0x04 - RW, SPI0 data buffer"]
    pub r8_spi0_buffer: R8_SPI0_BUFFER,
    #[doc = "0x05 - RO, SPI0 work flag"]
    pub r8_spi0_run_flag: R8_SPI0_RUN_FLAG,
    #[doc = "0x06 - RW1, SPI0 interrupt flag"]
    pub r8_spi0_int_flag: R8_SPI0_INT_FLAG,
    #[doc = "0x07 - RO, SPI0 FIFO count status"]
    pub r8_spi0_fifo_count: R8_SPI0_FIFO_COUNT,
    _reserved8: [u8; 0x04],
    #[doc = "0x0c - RW, SPI0 total byte count, only low 12 bit"]
    pub r16_spi0_total_cnt: R16_SPI0_TOTAL_CNT,
    _reserved9: [u8; 0x02],
    #[doc = "0x10 - RO/WO, SPI0 FIFO register"]
    pub r8_spi0_fifo: R8_SPI0_FIFO,
    _reserved10: [u8; 0x02],
    #[doc = "0x13 - RO, SPI0 FIFO count status"]
    pub r8_spi0_fifo_count1: R8_SPI0_FIFO_COUNT1,
    #[doc = "0x14 - RW, SPI0 DMA current address"]
    pub r16_spi0_dma_now: R16_SPI0_DMA_NOW,
    _reserved12: [u8; 0x02],
    #[doc = "0x18 - RW, SPI0 DMA begin address"]
    pub r16_spi0_dma_beg: R16_SPI0_DMA_BEG,
    _reserved13: [u8; 0x02],
    #[doc = "0x1c - RW, SPI0 DMA end address"]
    pub r16_spi0_dma_end: R16_SPI0_DMA_END,
}
#[doc = "R8_SPI0_CTRL_MOD (rw) register accessor: an alias for `Reg<R8_SPI0_CTRL_MOD_SPEC>`"]
pub type R8_SPI0_CTRL_MOD = crate::Reg<r8_spi0_ctrl_mod::R8_SPI0_CTRL_MOD_SPEC>;
#[doc = "RW, SPI0 mode control"]
pub mod r8_spi0_ctrl_mod;
#[doc = "R8_SPI0_CTRL_CFG (rw) register accessor: an alias for `Reg<R8_SPI0_CTRL_CFG_SPEC>`"]
pub type R8_SPI0_CTRL_CFG = crate::Reg<r8_spi0_ctrl_cfg::R8_SPI0_CTRL_CFG_SPEC>;
#[doc = "RW, SPI0 configuration control"]
pub mod r8_spi0_ctrl_cfg;
#[doc = "R8_SPI0_INTER_EN (rw) register accessor: an alias for `Reg<R8_SPI0_INTER_EN_SPEC>`"]
pub type R8_SPI0_INTER_EN = crate::Reg<r8_spi0_inter_en::R8_SPI0_INTER_EN_SPEC>;
#[doc = "RW, SPI0 interrupt enable"]
pub mod r8_spi0_inter_en;
#[doc = "R8_SPI0_CLOCK_DIV__R8_SPI0_SLAVE_PRE (rw) register accessor: an alias for `Reg<R8_SPI0_CLOCK_DIV__R8_SPI0_SLAVE_PRE_SPEC>`"]
pub type R8_SPI0_CLOCK_DIV__R8_SPI0_SLAVE_PRE =
    crate::Reg<r8_spi0_clock_div__r8_spi0_slave_pre::R8_SPI0_CLOCK_DIV__R8_SPI0_SLAVE_PRE_SPEC>;
#[doc = "RW, SPI0 master clock divisor;RW, SPI0 slave preset value"]
pub mod r8_spi0_clock_div__r8_spi0_slave_pre;
#[doc = "R8_SPI0_BUFFER (rw) register accessor: an alias for `Reg<R8_SPI0_BUFFER_SPEC>`"]
pub type R8_SPI0_BUFFER = crate::Reg<r8_spi0_buffer::R8_SPI0_BUFFER_SPEC>;
#[doc = "RW, SPI0 data buffer"]
pub mod r8_spi0_buffer;
#[doc = "R8_SPI0_RUN_FLAG (r) register accessor: an alias for `Reg<R8_SPI0_RUN_FLAG_SPEC>`"]
pub type R8_SPI0_RUN_FLAG = crate::Reg<r8_spi0_run_flag::R8_SPI0_RUN_FLAG_SPEC>;
#[doc = "RO, SPI0 work flag"]
pub mod r8_spi0_run_flag;
#[doc = "R8_SPI0_INT_FLAG (rw) register accessor: an alias for `Reg<R8_SPI0_INT_FLAG_SPEC>`"]
pub type R8_SPI0_INT_FLAG = crate::Reg<r8_spi0_int_flag::R8_SPI0_INT_FLAG_SPEC>;
#[doc = "RW1, SPI0 interrupt flag"]
pub mod r8_spi0_int_flag;
#[doc = "R8_SPI0_FIFO_COUNT (r) register accessor: an alias for `Reg<R8_SPI0_FIFO_COUNT_SPEC>`"]
pub type R8_SPI0_FIFO_COUNT = crate::Reg<r8_spi0_fifo_count::R8_SPI0_FIFO_COUNT_SPEC>;
#[doc = "RO, SPI0 FIFO count status"]
pub mod r8_spi0_fifo_count;
#[doc = "R16_SPI0_TOTAL_CNT (rw) register accessor: an alias for `Reg<R16_SPI0_TOTAL_CNT_SPEC>`"]
pub type R16_SPI0_TOTAL_CNT = crate::Reg<r16_spi0_total_cnt::R16_SPI0_TOTAL_CNT_SPEC>;
#[doc = "RW, SPI0 total byte count, only low 12 bit"]
pub mod r16_spi0_total_cnt;
#[doc = "R8_SPI0_FIFO (rw) register accessor: an alias for `Reg<R8_SPI0_FIFO_SPEC>`"]
pub type R8_SPI0_FIFO = crate::Reg<r8_spi0_fifo::R8_SPI0_FIFO_SPEC>;
#[doc = "RO/WO, SPI0 FIFO register"]
pub mod r8_spi0_fifo;
#[doc = "R8_SPI0_FIFO_COUNT1 (r) register accessor: an alias for `Reg<R8_SPI0_FIFO_COUNT1_SPEC>`"]
pub type R8_SPI0_FIFO_COUNT1 = crate::Reg<r8_spi0_fifo_count1::R8_SPI0_FIFO_COUNT1_SPEC>;
#[doc = "RO, SPI0 FIFO count status"]
pub mod r8_spi0_fifo_count1;
#[doc = "R16_SPI0_DMA_NOW (rw) register accessor: an alias for `Reg<R16_SPI0_DMA_NOW_SPEC>`"]
pub type R16_SPI0_DMA_NOW = crate::Reg<r16_spi0_dma_now::R16_SPI0_DMA_NOW_SPEC>;
#[doc = "RW, SPI0 DMA current address"]
pub mod r16_spi0_dma_now;
#[doc = "R16_SPI0_DMA_BEG (rw) register accessor: an alias for `Reg<R16_SPI0_DMA_BEG_SPEC>`"]
pub type R16_SPI0_DMA_BEG = crate::Reg<r16_spi0_dma_beg::R16_SPI0_DMA_BEG_SPEC>;
#[doc = "RW, SPI0 DMA begin address"]
pub mod r16_spi0_dma_beg;
#[doc = "R16_SPI0_DMA_END (rw) register accessor: an alias for `Reg<R16_SPI0_DMA_END_SPEC>`"]
pub type R16_SPI0_DMA_END = crate::Reg<r16_spi0_dma_end::R16_SPI0_DMA_END_SPEC>;
#[doc = "RW, SPI0 DMA end address"]
pub mod r16_spi0_dma_end;
