#[doc = "Register `R16_CLK_SYS_CFG` reader"]
pub struct R(crate::R<R16_CLK_SYS_CFG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R16_CLK_SYS_CFG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R16_CLK_SYS_CFG_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R16_CLK_SYS_CFG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R16_CLK_SYS_CFG` writer"]
pub struct W(crate::W<R16_CLK_SYS_CFG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R16_CLK_SYS_CFG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R16_CLK_SYS_CFG_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R16_CLK_SYS_CFG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_CLK_PLL_DIV` reader - RWA, output clock divider from PLL or CK32M"]
pub type RB_CLK_PLL_DIV_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_CLK_PLL_DIV` writer - RWA, output clock divider from PLL or CK32M"]
pub type RB_CLK_PLL_DIV_W<'a, const O: u8> =
    crate::FieldWriter<'a, u16, R16_CLK_SYS_CFG_SPEC, u8, u8, 5, O>;
#[doc = "Field `RB_CLK_SYS_MOD` reader - RWA, system clock source mode: 00=divided from 32MHz, 01=divided from PLL-480MHz, 10=directly from 32MHz, 11=directly from 32KHz"]
pub type RB_CLK_SYS_MOD_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_CLK_SYS_MOD` writer - RWA, system clock source mode: 00=divided from 32MHz, 01=divided from PLL-480MHz, 10=directly from 32MHz, 11=directly from 32KHz"]
pub type RB_CLK_SYS_MOD_W<'a, const O: u8> =
    crate::FieldWriter<'a, u16, R16_CLK_SYS_CFG_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_CLK_OSC32M_XT` reader - RWA, 32MHz clock source selection: 0=internal 32MHz oscillator, 1=external 32MHz oscillator"]
pub type RB_CLK_OSC32M_XT_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_OSC32M_XT` writer - RWA, 32MHz clock source selection: 0=internal 32MHz oscillator, 1=external 32MHz oscillator"]
pub type RB_CLK_OSC32M_XT_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_CLK_SYS_CFG_SPEC, bool, O>;
#[doc = "Field `RB_XO_DI` reader - RO, X32MO input status sample value"]
pub type RB_XO_DI_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bits 0:4 - RWA, output clock divider from PLL or CK32M"]
    #[inline(always)]
    pub fn rb_clk_pll_div(&self) -> RB_CLK_PLL_DIV_R {
        RB_CLK_PLL_DIV_R::new((self.bits & 0x1f) as u8)
    }
    #[doc = "Bits 6:7 - RWA, system clock source mode: 00=divided from 32MHz, 01=divided from PLL-480MHz, 10=directly from 32MHz, 11=directly from 32KHz"]
    #[inline(always)]
    pub fn rb_clk_sys_mod(&self) -> RB_CLK_SYS_MOD_R {
        RB_CLK_SYS_MOD_R::new(((self.bits >> 6) & 3) as u8)
    }
    #[doc = "Bit 9 - RWA, 32MHz clock source selection: 0=internal 32MHz oscillator, 1=external 32MHz oscillator"]
    #[inline(always)]
    pub fn rb_clk_osc32m_xt(&self) -> RB_CLK_OSC32M_XT_R {
        RB_CLK_OSC32M_XT_R::new(((self.bits >> 9) & 1) != 0)
    }
    #[doc = "Bit 15 - RO, X32MO input status sample value"]
    #[inline(always)]
    pub fn rb_xo_di(&self) -> RB_XO_DI_R {
        RB_XO_DI_R::new(((self.bits >> 15) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:4 - RWA, output clock divider from PLL or CK32M"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_pll_div(&mut self) -> RB_CLK_PLL_DIV_W<0> {
        RB_CLK_PLL_DIV_W::new(self)
    }
    #[doc = "Bits 6:7 - RWA, system clock source mode: 00=divided from 32MHz, 01=divided from PLL-480MHz, 10=directly from 32MHz, 11=directly from 32KHz"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_sys_mod(&mut self) -> RB_CLK_SYS_MOD_W<6> {
        RB_CLK_SYS_MOD_W::new(self)
    }
    #[doc = "Bit 9 - RWA, 32MHz clock source selection: 0=internal 32MHz oscillator, 1=external 32MHz oscillator"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_osc32m_xt(&mut self) -> RB_CLK_OSC32M_XT_W<9> {
        RB_CLK_OSC32M_XT_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, system clock configuration, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r16_clk_sys_cfg](index.html) module"]
pub struct R16_CLK_SYS_CFG_SPEC;
impl crate::RegisterSpec for R16_CLK_SYS_CFG_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [r16_clk_sys_cfg::R](R) reader structure"]
impl crate::Readable for R16_CLK_SYS_CFG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r16_clk_sys_cfg::W](W) writer structure"]
impl crate::Writable for R16_CLK_SYS_CFG_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R16_CLK_SYS_CFG to value 0"]
impl crate::Resettable for R16_CLK_SYS_CFG_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
