#[doc = "Register `R16_INT32K_TUNE` reader"]
pub struct R(crate::R<R16_INT32K_TUNE_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R16_INT32K_TUNE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R16_INT32K_TUNE_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R16_INT32K_TUNE_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R16_INT32K_TUNE` writer"]
pub struct W(crate::W<R16_INT32K_TUNE_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R16_INT32K_TUNE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R16_INT32K_TUNE_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R16_INT32K_TUNE_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_INT32K_TUNE` reader - RWA, internal 32KHz oscillator frequency tune"]
pub type RB_INT32K_TUNE_R = crate::FieldReader<u16, u16>;
#[doc = "Field `RB_INT32K_TUNE` writer - RWA, internal 32KHz oscillator frequency tune"]
pub type RB_INT32K_TUNE_W<'a, const O: u8> =
    crate::FieldWriter<'a, u16, R16_INT32K_TUNE_SPEC, u16, u16, 10, O>;
impl R {
    #[doc = "Bits 0:9 - RWA, internal 32KHz oscillator frequency tune"]
    #[inline(always)]
    pub fn rb_int32k_tune(&self) -> RB_INT32K_TUNE_R {
        RB_INT32K_TUNE_R::new(self.bits & 0x03ff)
    }
}
impl W {
    #[doc = "Bits 0:9 - RWA, internal 32KHz oscillator frequency tune"]
    #[inline(always)]
    #[must_use]
    pub fn rb_int32k_tune(&mut self) -> RB_INT32K_TUNE_W<0> {
        RB_INT32K_TUNE_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, internal 32KHz oscillator tune control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r16_int32k_tune](index.html) module"]
pub struct R16_INT32K_TUNE_SPEC;
impl crate::RegisterSpec for R16_INT32K_TUNE_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [r16_int32k_tune::R](R) reader structure"]
impl crate::Readable for R16_INT32K_TUNE_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r16_int32k_tune::W](W) writer structure"]
impl crate::Writable for R16_INT32K_TUNE_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R16_INT32K_TUNE to value 0"]
impl crate::Resettable for R16_INT32K_TUNE_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
