#[doc = "Register `R8_ADC_CONVERT` reader"]
pub struct R(crate::R<R8_ADC_CONVERT_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_ADC_CONVERT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_ADC_CONVERT_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_ADC_CONVERT_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_ADC_CONVERT` writer"]
pub struct W(crate::W<R8_ADC_CONVERT_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_ADC_CONVERT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_ADC_CONVERT_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_ADC_CONVERT_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_ADC_START` reader - RW, ADC convert start control: 0=stop ADC convert, 1=start an ADC convert, auto clear"]
pub type RB_ADC_START_R = crate::BitReader<bool>;
#[doc = "Field `RB_ADC_START` writer - RW, ADC convert start control: 0=stop ADC convert, 1=start an ADC convert, auto clear"]
pub type RB_ADC_START_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_ADC_CONVERT_SPEC, bool, O>;
#[doc = "Field `RB_TKEY_PWR_ON` reader - RW, Touchkey power on: 0=power down, 1=power on"]
pub type RB_TKEY_PWR_ON_R = crate::BitReader<bool>;
#[doc = "Field `RB_TKEY_PWR_ON` writer - RW, Touchkey power on: 0=power down, 1=power on"]
pub type RB_TKEY_PWR_ON_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_ADC_CONVERT_SPEC, bool, O>;
#[doc = "Field `RB_TKEY_ACTION` reader - RO, Touchkey action status: 0=free, 1=discharge or charge or ADC"]
pub type RB_TKEY_ACTION_R = crate::BitReader<bool>;
#[doc = "Field `RB_TKEY_CHG_ACT` reader - RO, Touchkey capacity charge status: 0=free, 1=charge"]
pub type RB_TKEY_CHG_ACT_R = crate::BitReader<bool>;
#[doc = "Field `RB_ADC_EOC_X` reader - RO, end of ADC conversion flag"]
pub type RB_ADC_EOC_X_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 0 - RW, ADC convert start control: 0=stop ADC convert, 1=start an ADC convert, auto clear"]
    #[inline(always)]
    pub fn rb_adc_start(&self) -> RB_ADC_START_R {
        RB_ADC_START_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 3 - RW, Touchkey power on: 0=power down, 1=power on"]
    #[inline(always)]
    pub fn rb_tkey_pwr_on(&self) -> RB_TKEY_PWR_ON_R {
        RB_TKEY_PWR_ON_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RO, Touchkey action status: 0=free, 1=discharge or charge or ADC"]
    #[inline(always)]
    pub fn rb_tkey_action(&self) -> RB_TKEY_ACTION_R {
        RB_TKEY_ACTION_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RO, Touchkey capacity charge status: 0=free, 1=charge"]
    #[inline(always)]
    pub fn rb_tkey_chg_act(&self) -> RB_TKEY_CHG_ACT_R {
        RB_TKEY_CHG_ACT_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 7 - RO, end of ADC conversion flag"]
    #[inline(always)]
    pub fn rb_adc_eoc_x(&self) -> RB_ADC_EOC_X_R {
        RB_ADC_EOC_X_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, ADC convert start control: 0=stop ADC convert, 1=start an ADC convert, auto clear"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_start(&mut self) -> RB_ADC_START_W<0> {
        RB_ADC_START_W::new(self)
    }
    #[doc = "Bit 3 - RW, Touchkey power on: 0=power down, 1=power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_tkey_pwr_on(&mut self) -> RB_TKEY_PWR_ON_W<3> {
        RB_TKEY_PWR_ON_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, ADC convert control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_adc_convert](index.html) module"]
pub struct R8_ADC_CONVERT_SPEC;
impl crate::RegisterSpec for R8_ADC_CONVERT_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_adc_convert::R](R) reader structure"]
impl crate::Readable for R8_ADC_CONVERT_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_adc_convert::W](W) writer structure"]
impl crate::Writable for R8_ADC_CONVERT_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_ADC_CONVERT to value 0"]
impl crate::Resettable for R8_ADC_CONVERT_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
