#[doc = "Register `R8_AUX_POWER_ADJ` reader"]
pub struct R(crate::R<R8_AUX_POWER_ADJ_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_AUX_POWER_ADJ_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_AUX_POWER_ADJ_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_AUX_POWER_ADJ_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_AUX_POWER_ADJ` writer"]
pub struct W(crate::W<R8_AUX_POWER_ADJ_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_AUX_POWER_ADJ_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_AUX_POWER_ADJ_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_AUX_POWER_ADJ_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_ULPLDO_ADJ` reader - RWA, Ultra-Low-Power LDO voltage adjust"]
pub type RB_ULPLDO_ADJ_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_ULPLDO_ADJ` writer - RWA, Ultra-Low-Power LDO voltage adjust"]
pub type RB_ULPLDO_ADJ_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_AUX_POWER_ADJ_SPEC, u8, u8, 3, O>;
#[doc = "Field `Reserved_1xx` reader - Reserved_1xx"]
pub type RESERVED_1XX_R = crate::FieldReader<u8, u8>;
impl R {
    #[doc = "Bits 0:2 - RWA, Ultra-Low-Power LDO voltage adjust"]
    #[inline(always)]
    pub fn rb_ulpldo_adj(&self) -> RB_ULPLDO_ADJ_R {
        RB_ULPLDO_ADJ_R::new(self.bits & 7)
    }
    #[doc = "Bits 3:5 - Reserved_1xx"]
    #[inline(always)]
    pub fn reserved_1xx(&self) -> RESERVED_1XX_R {
        RESERVED_1XX_R::new((self.bits >> 3) & 7)
    }
}
impl W {
    #[doc = "Bits 0:2 - RWA, Ultra-Low-Power LDO voltage adjust"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ulpldo_adj(&mut self) -> RB_ULPLDO_ADJ_W<0> {
        RB_ULPLDO_ADJ_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, aux power adjust control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_aux_power_adj](index.html) module"]
pub struct R8_AUX_POWER_ADJ_SPEC;
impl crate::RegisterSpec for R8_AUX_POWER_ADJ_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_aux_power_adj::R](R) reader structure"]
impl crate::Readable for R8_AUX_POWER_ADJ_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_aux_power_adj::W](W) writer structure"]
impl crate::Writable for R8_AUX_POWER_ADJ_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_AUX_POWER_ADJ to value 0"]
impl crate::Resettable for R8_AUX_POWER_ADJ_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
