#[doc = "Register `R8_GLOB_CFG_INFO` reader"]
pub struct R(crate::R<R8_GLOB_CFG_INFO_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_GLOB_CFG_INFO_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_GLOB_CFG_INFO_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_GLOB_CFG_INFO_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Field `RB_CFG_ROM_READ` reader - RO, indicate protected status of Flash ROM code and data: 0=reading protect, 1=enable read by external programmer"]
pub type RB_CFG_ROM_READ_R = crate::BitReader<bool>;
#[doc = "Field `RB_CFG_RESET_EN` reader - RO, manual reset input enable status"]
pub type RB_CFG_RESET_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_CFG_BOOT_EN` reader - RO, boot-loader enable status"]
pub type RB_CFG_BOOT_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_CFG_DEBUG_EN` reader - RO, debug enable status"]
pub type RB_CFG_DEBUG_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_BOOT_LOADER` reader - RO, indicate boot loader status: 0=application status (by software reset), 1=boot loader status"]
pub type RB_BOOT_LOADER_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 0 - RO, indicate protected status of Flash ROM code and data: 0=reading protect, 1=enable read by external programmer"]
    #[inline(always)]
    pub fn rb_cfg_rom_read(&self) -> RB_CFG_ROM_READ_R {
        RB_CFG_ROM_READ_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 2 - RO, manual reset input enable status"]
    #[inline(always)]
    pub fn rb_cfg_reset_en(&self) -> RB_CFG_RESET_EN_R {
        RB_CFG_RESET_EN_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RO, boot-loader enable status"]
    #[inline(always)]
    pub fn rb_cfg_boot_en(&self) -> RB_CFG_BOOT_EN_R {
        RB_CFG_BOOT_EN_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RO, debug enable status"]
    #[inline(always)]
    pub fn rb_cfg_debug_en(&self) -> RB_CFG_DEBUG_EN_R {
        RB_CFG_DEBUG_EN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RO, indicate boot loader status: 0=application status (by software reset), 1=boot loader status"]
    #[inline(always)]
    pub fn rb_boot_loader(&self) -> RB_BOOT_LOADER_R {
        RB_BOOT_LOADER_R::new(((self.bits >> 5) & 1) != 0)
    }
}
#[doc = "RO, global configuration information and status\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_glob_cfg_info](index.html) module"]
pub struct R8_GLOB_CFG_INFO_SPEC;
impl crate::RegisterSpec for R8_GLOB_CFG_INFO_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_glob_cfg_info::R](R) reader structure"]
impl crate::Readable for R8_GLOB_CFG_INFO_SPEC {
    type Reader = R;
}
#[doc = "`reset()` method sets R8_GLOB_CFG_INFO to value 0"]
impl crate::Resettable for R8_GLOB_CFG_INFO_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
