#[doc = "Register `R8_HFCK_PWR_CTRL` reader"]
pub struct R(crate::R<R8_HFCK_PWR_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_HFCK_PWR_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_HFCK_PWR_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_HFCK_PWR_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_HFCK_PWR_CTRL` writer"]
pub struct W(crate::W<R8_HFCK_PWR_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_HFCK_PWR_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_HFCK_PWR_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_HFCK_PWR_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_CLK_XT32M_PON` reader - RWA, external 32MHz oscillator power control: 0=power down, 1-power on"]
pub type RB_CLK_XT32M_PON_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_XT32M_PON` writer - RWA, external 32MHz oscillator power control: 0=power down, 1-power on"]
pub type RB_CLK_XT32M_PON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_HFCK_PWR_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_CLK_INT32M_PON` reader - RWA, internal 32MHz oscillator power control: 0=power down, 1-power on"]
pub type RB_CLK_INT32M_PON_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_INT32M_PON` writer - RWA, internal 32MHz oscillator power control: 0=power down, 1-power on"]
pub type RB_CLK_INT32M_PON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_HFCK_PWR_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_CLK_PLL_PON` reader - RWA, PLL power control: 0=power down, 1-power on"]
pub type RB_CLK_PLL_PON_R = crate::BitReader<bool>;
#[doc = "Field `RB_CLK_PLL_PON` writer - RWA, PLL power control: 0=power down, 1-power on"]
pub type RB_CLK_PLL_PON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_HFCK_PWR_CTRL_SPEC, bool, O>;
impl R {
    #[doc = "Bit 2 - RWA, external 32MHz oscillator power control: 0=power down, 1-power on"]
    #[inline(always)]
    pub fn rb_clk_xt32m_pon(&self) -> RB_CLK_XT32M_PON_R {
        RB_CLK_XT32M_PON_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RWA, internal 32MHz oscillator power control: 0=power down, 1-power on"]
    #[inline(always)]
    pub fn rb_clk_int32m_pon(&self) -> RB_CLK_INT32M_PON_R {
        RB_CLK_INT32M_PON_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RWA, PLL power control: 0=power down, 1-power on"]
    #[inline(always)]
    pub fn rb_clk_pll_pon(&self) -> RB_CLK_PLL_PON_R {
        RB_CLK_PLL_PON_R::new(((self.bits >> 4) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 2 - RWA, external 32MHz oscillator power control: 0=power down, 1-power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_xt32m_pon(&mut self) -> RB_CLK_XT32M_PON_W<2> {
        RB_CLK_XT32M_PON_W::new(self)
    }
    #[doc = "Bit 3 - RWA, internal 32MHz oscillator power control: 0=power down, 1-power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_int32m_pon(&mut self) -> RB_CLK_INT32M_PON_W<3> {
        RB_CLK_INT32M_PON_W::new(self)
    }
    #[doc = "Bit 4 - RWA, PLL power control: 0=power down, 1-power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_clk_pll_pon(&mut self) -> RB_CLK_PLL_PON_W<4> {
        RB_CLK_PLL_PON_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, high frequency clock module power control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_hfck_pwr_ctrl](index.html) module"]
pub struct R8_HFCK_PWR_CTRL_SPEC;
impl crate::RegisterSpec for R8_HFCK_PWR_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_hfck_pwr_ctrl::R](R) reader structure"]
impl crate::Readable for R8_HFCK_PWR_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_hfck_pwr_ctrl::W](W) writer structure"]
impl crate::Writable for R8_HFCK_PWR_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_HFCK_PWR_CTRL to value 0"]
impl crate::Resettable for R8_HFCK_PWR_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
