#[doc = "Register `R8_PLL_CONFIG` reader"]
pub struct R(crate::R<R8_PLL_CONFIG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_PLL_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_PLL_CONFIG_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_PLL_CONFIG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_PLL_CONFIG` writer"]
pub struct W(crate::W<R8_PLL_CONFIG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_PLL_CONFIG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_PLL_CONFIG_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_PLL_CONFIG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_PLL_CFG_DAT` reader - RWA, PLL configure data"]
pub type RB_PLL_CFG_DAT_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_PLL_CFG_DAT` writer - RWA, PLL configure data"]
pub type RB_PLL_CFG_DAT_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_PLL_CONFIG_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_PLL_LOCKED` reader - RO, indicate PLL locked"]
pub type RB_PLL_LOCKED_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bits 0:1 - RWA, PLL configure data"]
    #[inline(always)]
    pub fn rb_pll_cfg_dat(&self) -> RB_PLL_CFG_DAT_R {
        RB_PLL_CFG_DAT_R::new(self.bits & 3)
    }
    #[doc = "Bit 7 - RO, indicate PLL locked"]
    #[inline(always)]
    pub fn rb_pll_locked(&self) -> RB_PLL_LOCKED_R {
        RB_PLL_LOCKED_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - RWA, PLL configure data"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pll_cfg_dat(&mut self) -> RB_PLL_CFG_DAT_W<0> {
        RB_PLL_CFG_DAT_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, PLL configuration control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_pll_config](index.html) module"]
pub struct R8_PLL_CONFIG_SPEC;
impl crate::RegisterSpec for R8_PLL_CONFIG_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_pll_config::R](R) reader structure"]
impl crate::Readable for R8_PLL_CONFIG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_pll_config::W](W) writer structure"]
impl crate::Writable for R8_PLL_CONFIG_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_PLL_CONFIG to value 0"]
impl crate::Resettable for R8_PLL_CONFIG_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
