#[doc = "Register `R8_SLP_POWER_CTRL` reader"]
pub struct R(crate::R<R8_SLP_POWER_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_SLP_POWER_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_SLP_POWER_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_SLP_POWER_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_SLP_POWER_CTRL` writer"]
pub struct W(crate::W<R8_SLP_POWER_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_SLP_POWER_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_SLP_POWER_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_SLP_POWER_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_SLP_ETH_PWR_DN` reader - RWA, enable ETH PHY power down"]
pub type RB_SLP_ETH_PWR_DN_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLP_ETH_PWR_DN` writer - RWA, enable ETH PHY power down"]
pub type RB_SLP_ETH_PWR_DN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_SLP_POWER_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_SLP_ROM_PWR_DN` reader - RWA, enable Flash ROM power down during halt"]
pub type RB_SLP_ROM_PWR_DN_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLP_ROM_PWR_DN` writer - RWA, enable Flash ROM power down during halt"]
pub type RB_SLP_ROM_PWR_DN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_SLP_POWER_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_SLP_CLK_RAMX` reader - RWA, close main SRAM clock"]
pub type RB_SLP_CLK_RAMX_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLP_CLK_RAMX` writer - RWA, close main SRAM clock"]
pub type RB_SLP_CLK_RAMX_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_SLP_POWER_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_SLP_CLK_RAM2K` reader - RWA, close retention 2KB SRAM clock"]
pub type RB_SLP_CLK_RAM2K_R = crate::BitReader<bool>;
#[doc = "Field `RB_SLP_CLK_RAM2K` writer - RWA, close retention 2KB SRAM clock"]
pub type RB_SLP_CLK_RAM2K_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_SLP_POWER_CTRL_SPEC, bool, O>;
impl R {
    #[doc = "Bit 1 - RWA, enable ETH PHY power down"]
    #[inline(always)]
    pub fn rb_slp_eth_pwr_dn(&self) -> RB_SLP_ETH_PWR_DN_R {
        RB_SLP_ETH_PWR_DN_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 3 - RWA, enable Flash ROM power down during halt"]
    #[inline(always)]
    pub fn rb_slp_rom_pwr_dn(&self) -> RB_SLP_ROM_PWR_DN_R {
        RB_SLP_ROM_PWR_DN_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RWA, close main SRAM clock"]
    #[inline(always)]
    pub fn rb_slp_clk_ramx(&self) -> RB_SLP_CLK_RAMX_R {
        RB_SLP_CLK_RAMX_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RWA, close retention 2KB SRAM clock"]
    #[inline(always)]
    pub fn rb_slp_clk_ram2k(&self) -> RB_SLP_CLK_RAM2K_R {
        RB_SLP_CLK_RAM2K_R::new(((self.bits >> 5) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 1 - RWA, enable ETH PHY power down"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slp_eth_pwr_dn(&mut self) -> RB_SLP_ETH_PWR_DN_W<1> {
        RB_SLP_ETH_PWR_DN_W::new(self)
    }
    #[doc = "Bit 3 - RWA, enable Flash ROM power down during halt"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slp_rom_pwr_dn(&mut self) -> RB_SLP_ROM_PWR_DN_W<3> {
        RB_SLP_ROM_PWR_DN_W::new(self)
    }
    #[doc = "Bit 4 - RWA, close main SRAM clock"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slp_clk_ramx(&mut self) -> RB_SLP_CLK_RAMX_W<4> {
        RB_SLP_CLK_RAMX_W::new(self)
    }
    #[doc = "Bit 5 - RWA, close retention 2KB SRAM clock"]
    #[inline(always)]
    #[must_use]
    pub fn rb_slp_clk_ram2k(&mut self) -> RB_SLP_CLK_RAM2K_W<5> {
        RB_SLP_CLK_RAM2K_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, peripherals power down control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_slp_power_ctrl](index.html) module"]
pub struct R8_SLP_POWER_CTRL_SPEC;
impl crate::RegisterSpec for R8_SLP_POWER_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_slp_power_ctrl::R](R) reader structure"]
impl crate::Readable for R8_SLP_POWER_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_slp_power_ctrl::W](W) writer structure"]
impl crate::Writable for R8_SLP_POWER_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_SLP_POWER_CTRL to value 0"]
impl crate::Resettable for R8_SLP_POWER_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
