#[doc = "Register `R8_TEM_SENSOR` reader"]
pub struct R(crate::R<R8_TEM_SENSOR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_TEM_SENSOR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_TEM_SENSOR_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_TEM_SENSOR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_TEM_SENSOR` writer"]
pub struct W(crate::W<R8_TEM_SENSOR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_TEM_SENSOR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_TEM_SENSOR_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_TEM_SENSOR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_TEM_SEN_CALIB` reader - RW, temperature sensor calibration"]
pub type RB_TEM_SEN_CALIB_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_TEM_SEN_CALIB` writer - RW, temperature sensor calibration"]
pub type RB_TEM_SEN_CALIB_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_TEM_SENSOR_SPEC, u8, u8, 3, O>;
#[doc = "Field `RB_TEM_SEN_PWR_ON` reader - RW, temperature sensor power control: 0=power down, 1=power on"]
pub type RB_TEM_SEN_PWR_ON_R = crate::BitReader<bool>;
#[doc = "Field `RB_TEM_SEN_PWR_ON` writer - RW, temperature sensor power control: 0=power down, 1=power on"]
pub type RB_TEM_SEN_PWR_ON_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_TEM_SENSOR_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:2 - RW, temperature sensor calibration"]
    #[inline(always)]
    pub fn rb_tem_sen_calib(&self) -> RB_TEM_SEN_CALIB_R {
        RB_TEM_SEN_CALIB_R::new(self.bits & 7)
    }
    #[doc = "Bit 7 - RW, temperature sensor power control: 0=power down, 1=power on"]
    #[inline(always)]
    pub fn rb_tem_sen_pwr_on(&self) -> RB_TEM_SEN_PWR_ON_R {
        RB_TEM_SEN_PWR_ON_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:2 - RW, temperature sensor calibration"]
    #[inline(always)]
    #[must_use]
    pub fn rb_tem_sen_calib(&mut self) -> RB_TEM_SEN_CALIB_W<0> {
        RB_TEM_SEN_CALIB_W::new(self)
    }
    #[doc = "Bit 7 - RW, temperature sensor power control: 0=power down, 1=power on"]
    #[inline(always)]
    #[must_use]
    pub fn rb_tem_sen_pwr_on(&mut self) -> RB_TEM_SEN_PWR_ON_W<7> {
        RB_TEM_SEN_PWR_ON_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, temperature sensor control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_tem_sensor](index.html) module"]
pub struct R8_TEM_SENSOR_SPEC;
impl crate::RegisterSpec for R8_TEM_SENSOR_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_tem_sensor::R](R) reader structure"]
impl crate::Readable for R8_TEM_SENSOR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_tem_sensor::W](W) writer structure"]
impl crate::Writable for R8_TEM_SENSOR_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_TEM_SENSOR to value 0"]
impl crate::Resettable for R8_TEM_SENSOR_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
