#[doc = "Register `R8_XT32K_TUNE` reader"]
pub struct R(crate::R<R8_XT32K_TUNE_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_XT32K_TUNE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_XT32K_TUNE_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_XT32K_TUNE_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_XT32K_TUNE` writer"]
pub struct W(crate::W<R8_XT32K_TUNE_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_XT32K_TUNE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_XT32K_TUNE_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_XT32K_TUNE_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_XT32K_I_TUNE` reader - RWA, external 32KHz oscillator current tune: 00=75% current, 01=standard current, 10=150% current, 11=200% current"]
pub type RB_XT32K_I_TUNE_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_XT32K_I_TUNE` writer - RWA, external 32KHz oscillator current tune: 00=75% current, 01=standard current, 10=150% current, 11=200% current"]
pub type RB_XT32K_I_TUNE_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_XT32K_TUNE_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_XT32K_C_LOAD` reader - RWA, external 32KHz oscillator load capacitor tune: Cap = RB_XT32K_C_LOAD + 12pF"]
pub type RB_XT32K_C_LOAD_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_XT32K_C_LOAD` writer - RWA, external 32KHz oscillator load capacitor tune: Cap = RB_XT32K_C_LOAD + 12pF"]
pub type RB_XT32K_C_LOAD_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_XT32K_TUNE_SPEC, u8, u8, 4, O>;
impl R {
    #[doc = "Bits 0:1 - RWA, external 32KHz oscillator current tune: 00=75% current, 01=standard current, 10=150% current, 11=200% current"]
    #[inline(always)]
    pub fn rb_xt32k_i_tune(&self) -> RB_XT32K_I_TUNE_R {
        RB_XT32K_I_TUNE_R::new(self.bits & 3)
    }
    #[doc = "Bits 4:7 - RWA, external 32KHz oscillator load capacitor tune: Cap = RB_XT32K_C_LOAD + 12pF"]
    #[inline(always)]
    pub fn rb_xt32k_c_load(&self) -> RB_XT32K_C_LOAD_R {
        RB_XT32K_C_LOAD_R::new((self.bits >> 4) & 0x0f)
    }
}
impl W {
    #[doc = "Bits 0:1 - RWA, external 32KHz oscillator current tune: 00=75% current, 01=standard current, 10=150% current, 11=200% current"]
    #[inline(always)]
    #[must_use]
    pub fn rb_xt32k_i_tune(&mut self) -> RB_XT32K_I_TUNE_W<0> {
        RB_XT32K_I_TUNE_W::new(self)
    }
    #[doc = "Bits 4:7 - RWA, external 32KHz oscillator load capacitor tune: Cap = RB_XT32K_C_LOAD + 12pF"]
    #[inline(always)]
    #[must_use]
    pub fn rb_xt32k_c_load(&mut self) -> RB_XT32K_C_LOAD_W<4> {
        RB_XT32K_C_LOAD_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, external 32KHz oscillator tune control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_xt32k_tune](index.html) module"]
pub struct R8_XT32K_TUNE_SPEC;
impl crate::RegisterSpec for R8_XT32K_TUNE_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_xt32k_tune::R](R) reader structure"]
impl crate::Readable for R8_XT32K_TUNE_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_xt32k_tune::W](W) writer structure"]
impl crate::Writable for R8_XT32K_TUNE_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_XT32K_TUNE to value 0"]
impl crate::Resettable for R8_XT32K_TUNE_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
