#[doc = "Register `R8_TMR1_CTRL_DMA` reader"]
pub struct R(crate::R<R8_TMR1_CTRL_DMA_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_TMR1_CTRL_DMA_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_TMR1_CTRL_DMA_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_TMR1_CTRL_DMA_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_TMR1_CTRL_DMA` writer"]
pub struct W(crate::W<R8_TMR1_CTRL_DMA_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_TMR1_CTRL_DMA_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_TMR1_CTRL_DMA_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_TMR1_CTRL_DMA_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_TMR_DMA_ENABLE` reader - RW, timer1/2 DMA enable"]
pub type RB_TMR_DMA_ENABLE_R = crate::BitReader<bool>;
#[doc = "Field `RB_TMR_DMA_ENABLE` writer - RW, timer1/2 DMA enable"]
pub type RB_TMR_DMA_ENABLE_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_TMR1_CTRL_DMA_SPEC, bool, O>;
#[doc = "Field `RB_TMR_DMA_LOOP` reader - RW, timer1/2 DMA address loop enable"]
pub type RB_TMR_DMA_LOOP_R = crate::BitReader<bool>;
#[doc = "Field `RB_TMR_DMA_LOOP` writer - RW, timer1/2 DMA address loop enable"]
pub type RB_TMR_DMA_LOOP_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_TMR1_CTRL_DMA_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, timer1/2 DMA enable"]
    #[inline(always)]
    pub fn rb_tmr_dma_enable(&self) -> RB_TMR_DMA_ENABLE_R {
        RB_TMR_DMA_ENABLE_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 2 - RW, timer1/2 DMA address loop enable"]
    #[inline(always)]
    pub fn rb_tmr_dma_loop(&self) -> RB_TMR_DMA_LOOP_R {
        RB_TMR_DMA_LOOP_R::new(((self.bits >> 2) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, timer1/2 DMA enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_tmr_dma_enable(&mut self) -> RB_TMR_DMA_ENABLE_W<0> {
        RB_TMR_DMA_ENABLE_W::new(self)
    }
    #[doc = "Bit 2 - RW, timer1/2 DMA address loop enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_tmr_dma_loop(&mut self) -> RB_TMR_DMA_LOOP_W<2> {
        RB_TMR_DMA_LOOP_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, TMR1 DMA control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_tmr1_ctrl_dma](index.html) module"]
pub struct R8_TMR1_CTRL_DMA_SPEC;
impl crate::RegisterSpec for R8_TMR1_CTRL_DMA_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_tmr1_ctrl_dma::R](R) reader structure"]
impl crate::Readable for R8_TMR1_CTRL_DMA_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_tmr1_ctrl_dma::W](W) writer structure"]
impl crate::Writable for R8_TMR1_CTRL_DMA_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_TMR1_CTRL_DMA to value 0"]
impl crate::Resettable for R8_TMR1_CTRL_DMA_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
