#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - RW, UART1 modem control"]
    pub r8_uart1_mcr: R8_UART1_MCR,
    #[doc = "0x01 - RW, UART1 interrupt enable"]
    pub r8_uart1_ier: R8_UART1_IER,
    #[doc = "0x02 - RW, UART1 FIFO control"]
    pub r8_uart1_fcr: R8_UART1_FCR,
    #[doc = "0x03 - RW, UART1 line control"]
    pub r8_uart1_lcr: R8_UART1_LCR,
    #[doc = "0x04 - RO, UART1 interrupt identification"]
    pub r8_uart1_iir: R8_UART1_IIR,
    #[doc = "0x05 - RO, UART1 line status"]
    pub r8_uart1_lsr: R8_UART1_LSR,
    _reserved6: [u8; 0x02],
    _reserved_6_r8_uart1: [u8; 0x01],
    _reserved7: [u8; 0x01],
    #[doc = "0x0a - RO, UART1 receiver FIFO count"]
    pub r8_uart1_rfc: R8_UART1_RFC,
    #[doc = "0x0b - RO, UART1 transmitter FIFO count"]
    pub r8_uart1_tfc: R8_UART1_TFC,
    #[doc = "0x0c - RW, UART1 divisor latch"]
    pub r16_uart1_dl: R16_UART1_DL,
    #[doc = "0x0e - RW, UART1 pre-divisor latch byte, only low 7 bit, from 1 to 0/128"]
    pub r8_uart1_div: R8_UART1_DIV,
}
impl RegisterBlock {
    #[doc = "0x08 - WO, UART1 transmitter holding, transmittal byte"]
    #[inline(always)]
    pub const fn r8_uart1_thr(&self) -> &R8_UART1_THR {
        unsafe { &*(self as *const Self).cast::<u8>().add(8usize).cast() }
    }
    #[doc = "0x08 - RO, UART1 receiver buffer, receiving byte"]
    #[inline(always)]
    pub const fn r8_uart1_rbr(&self) -> &R8_UART1_RBR {
        unsafe { &*(self as *const Self).cast::<u8>().add(8usize).cast() }
    }
}
#[doc = "R8_UART1_MCR (rw) register accessor: an alias for `Reg<R8_UART1_MCR_SPEC>`"]
pub type R8_UART1_MCR = crate::Reg<r8_uart1_mcr::R8_UART1_MCR_SPEC>;
#[doc = "RW, UART1 modem control"]
pub mod r8_uart1_mcr;
#[doc = "R8_UART1_IER (rw) register accessor: an alias for `Reg<R8_UART1_IER_SPEC>`"]
pub type R8_UART1_IER = crate::Reg<r8_uart1_ier::R8_UART1_IER_SPEC>;
#[doc = "RW, UART1 interrupt enable"]
pub mod r8_uart1_ier;
#[doc = "R8_UART1_FCR (rw) register accessor: an alias for `Reg<R8_UART1_FCR_SPEC>`"]
pub type R8_UART1_FCR = crate::Reg<r8_uart1_fcr::R8_UART1_FCR_SPEC>;
#[doc = "RW, UART1 FIFO control"]
pub mod r8_uart1_fcr;
#[doc = "R8_UART1_LCR (rw) register accessor: an alias for `Reg<R8_UART1_LCR_SPEC>`"]
pub type R8_UART1_LCR = crate::Reg<r8_uart1_lcr::R8_UART1_LCR_SPEC>;
#[doc = "RW, UART1 line control"]
pub mod r8_uart1_lcr;
#[doc = "R8_UART1_IIR (r) register accessor: an alias for `Reg<R8_UART1_IIR_SPEC>`"]
pub type R8_UART1_IIR = crate::Reg<r8_uart1_iir::R8_UART1_IIR_SPEC>;
#[doc = "RO, UART1 interrupt identification"]
pub mod r8_uart1_iir;
#[doc = "R8_UART1_LSR (r) register accessor: an alias for `Reg<R8_UART1_LSR_SPEC>`"]
pub type R8_UART1_LSR = crate::Reg<r8_uart1_lsr::R8_UART1_LSR_SPEC>;
#[doc = "RO, UART1 line status"]
pub mod r8_uart1_lsr;
#[doc = "R8_UART1_RBR (r) register accessor: an alias for `Reg<R8_UART1_RBR_SPEC>`"]
pub type R8_UART1_RBR = crate::Reg<r8_uart1_rbr::R8_UART1_RBR_SPEC>;
#[doc = "RO, UART1 receiver buffer, receiving byte"]
pub mod r8_uart1_rbr;
#[doc = "R8_UART1_THR (w) register accessor: an alias for `Reg<R8_UART1_THR_SPEC>`"]
pub type R8_UART1_THR = crate::Reg<r8_uart1_thr::R8_UART1_THR_SPEC>;
#[doc = "WO, UART1 transmitter holding, transmittal byte"]
pub mod r8_uart1_thr;
#[doc = "R8_UART1_RFC (r) register accessor: an alias for `Reg<R8_UART1_RFC_SPEC>`"]
pub type R8_UART1_RFC = crate::Reg<r8_uart1_rfc::R8_UART1_RFC_SPEC>;
#[doc = "RO, UART1 receiver FIFO count"]
pub mod r8_uart1_rfc;
#[doc = "R8_UART1_TFC (r) register accessor: an alias for `Reg<R8_UART1_TFC_SPEC>`"]
pub type R8_UART1_TFC = crate::Reg<r8_uart1_tfc::R8_UART1_TFC_SPEC>;
#[doc = "RO, UART1 transmitter FIFO count"]
pub mod r8_uart1_tfc;
#[doc = "R16_UART1_DL (rw) register accessor: an alias for `Reg<R16_UART1_DL_SPEC>`"]
pub type R16_UART1_DL = crate::Reg<r16_uart1_dl::R16_UART1_DL_SPEC>;
#[doc = "RW, UART1 divisor latch"]
pub mod r16_uart1_dl;
#[doc = "R8_UART1_DIV (rw) register accessor: an alias for `Reg<R8_UART1_DIV_SPEC>`"]
pub type R8_UART1_DIV = crate::Reg<r8_uart1_div::R8_UART1_DIV_SPEC>;
#[doc = "RW, UART1 pre-divisor latch byte, only low 7 bit, from 1 to 0/128"]
pub mod r8_uart1_div;
