#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - USB base control"]
    pub r8_usb_ctrl: R8_USB_CTRL,
    #[doc = "0x01 - USB device physical prot control"]
    pub r8_udev_ctrl__r8_uhost_ctrl: R8_UDEV_CTRL__R8_UHOST_CTRL,
    #[doc = "0x02 - USB interrupt enable"]
    pub r8_usb_int_en: R8_USB_INT_EN,
    #[doc = "0x03 - USB device address"]
    pub r8_usb_dev_ad: R8_USB_DEV_AD,
    _reserved4: [u8; 0x01],
    #[doc = "0x05 - USB miscellaneous status"]
    pub r8_usb_mis_st: R8_USB_MIS_ST,
    #[doc = "0x06 - USB interrupt flag"]
    pub r8_usb_int_fg: R8_USB_INT_FG,
    #[doc = "0x07 - USB interrupt status"]
    pub r8_usb_int_st: R8_USB_INT_ST,
    #[doc = "0x08 - USB receiving length"]
    pub r8_usb_rx_len: R8_USB_RX_LEN,
    _reserved8: [u8; 0x03],
    #[doc = "0x0c - endpoint 4/1 mode"]
    pub r8_uep4_1_mod: R8_UEP4_1_MOD,
    #[doc = "0x0d - endpoint 2/3 mode;host endpoint mode"]
    pub r8_uep2_3_mod__r8_uh_ep_mod: R8_UEP2_3_MOD__R8_UH_EP_MOD,
    _reserved10: [u8; 0x02],
    #[doc = "0x10 - endpoint 0 DMA buffer address"]
    pub r16_uep0_dma: R16_UEP0_DMA,
    _reserved11: [u8; 0x02],
    #[doc = "0x14 - endpoint 1 DMA buffer address"]
    pub r16_uep1_dma: R16_UEP1_DMA,
    _reserved12: [u8; 0x02],
    #[doc = "0x18 - endpoint 2 DMA buffer address;host rx endpoint buffer high address"]
    pub r16_uep2_dma__r16_uh_rx_dma: R16_UEP2_DMA__R16_UH_RX_DMA,
    _reserved13: [u8; 0x02],
    #[doc = "0x1c - endpoint 3 DMA buffer address;host tx endpoint buffer high address"]
    pub r16_uep3_dma__r16_uh_tx_dma: R16_UEP3_DMA__R16_UH_TX_DMA,
    _reserved14: [u8; 0x02],
    #[doc = "0x20 - endpoint 0 transmittal length"]
    pub r8_uep0_t_len: R8_UEP0_T_LEN,
    _reserved15: [u8; 0x01],
    #[doc = "0x22 - endpoint 0 control"]
    pub r8_uep0_ctrl: R8_UEP0_CTRL,
    _reserved16: [u8; 0x01],
    #[doc = "0x24 - endpoint 1 transmittal length"]
    pub r8_uep1_t_len: R8_UEP1_T_LEN,
    _reserved17: [u8; 0x01],
    #[doc = "0x26 - endpoint 1 control;host aux setup"]
    pub r8_uep1_ctrl__r8_uh_setup: R8_UEP1_CTRL__R8_UH_SETUP,
    _reserved18: [u8; 0x01],
    #[doc = "0x28 - endpoint 2 transmittal length;host endpoint and PID"]
    pub r8_uep2_t_len__r8_uh_ep_pid: R8_UEP2_T_LEN__R8_UH_EP_PID,
    _reserved19: [u8; 0x01],
    #[doc = "0x2a - endpoint 2 control;host receiver endpoint control"]
    pub r8_uep2_ctrl__r8_uh_rx_ctrl: R8_UEP2_CTRL__R8_UH_RX_CTRL,
    _reserved20: [u8; 0x01],
    #[doc = "0x2c - endpoint 3 transmittal length;host transmittal endpoint transmittal length"]
    pub r8_uep3_t_len__r8_uh_tx_len: R8_UEP3_T_LEN__R8_UH_TX_LEN,
    _reserved21: [u8; 0x01],
    #[doc = "0x2e - endpoint 3 control;host transmittal endpoint control"]
    pub r8_uep3_ctrl__r8_uh_tx_ctrl: R8_UEP3_CTRL__R8_UH_TX_CTRL,
    _reserved22: [u8; 0x01],
    #[doc = "0x30 - endpoint 4 transmittal length"]
    pub r8_uep4_t_len: R8_UEP4_T_LEN,
    _reserved23: [u8; 0x01],
    #[doc = "0x32 - endpoint 4 control"]
    pub r8_uep4_ctrl: R8_UEP4_CTRL,
    _reserved24: [u8; 0x05],
    #[doc = "0x38 - USB type-C control"]
    pub r8_usb_type_c_ctrl: R8_USB_TYPE_C_CTRL,
}
#[doc = "R8_USB_CTRL (rw) register accessor: an alias for `Reg<R8_USB_CTRL_SPEC>`"]
pub type R8_USB_CTRL = crate::Reg<r8_usb_ctrl::R8_USB_CTRL_SPEC>;
#[doc = "USB base control"]
pub mod r8_usb_ctrl;
#[doc = "R8_UDEV_CTRL__R8_UHOST_CTRL (rw) register accessor: an alias for `Reg<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>`"]
pub type R8_UDEV_CTRL__R8_UHOST_CTRL =
    crate::Reg<r8_udev_ctrl__r8_uhost_ctrl::R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>;
#[doc = "USB device physical prot control"]
pub mod r8_udev_ctrl__r8_uhost_ctrl;
#[doc = "R8_USB_INT_EN (rw) register accessor: an alias for `Reg<R8_USB_INT_EN_SPEC>`"]
pub type R8_USB_INT_EN = crate::Reg<r8_usb_int_en::R8_USB_INT_EN_SPEC>;
#[doc = "USB interrupt enable"]
pub mod r8_usb_int_en;
#[doc = "R8_USB_DEV_AD (rw) register accessor: an alias for `Reg<R8_USB_DEV_AD_SPEC>`"]
pub type R8_USB_DEV_AD = crate::Reg<r8_usb_dev_ad::R8_USB_DEV_AD_SPEC>;
#[doc = "USB device address"]
pub mod r8_usb_dev_ad;
#[doc = "R8_USB_MIS_ST (r) register accessor: an alias for `Reg<R8_USB_MIS_ST_SPEC>`"]
pub type R8_USB_MIS_ST = crate::Reg<r8_usb_mis_st::R8_USB_MIS_ST_SPEC>;
#[doc = "USB miscellaneous status"]
pub mod r8_usb_mis_st;
#[doc = "R8_USB_INT_FG (rw) register accessor: an alias for `Reg<R8_USB_INT_FG_SPEC>`"]
pub type R8_USB_INT_FG = crate::Reg<r8_usb_int_fg::R8_USB_INT_FG_SPEC>;
#[doc = "USB interrupt flag"]
pub mod r8_usb_int_fg;
#[doc = "R8_USB_INT_ST (r) register accessor: an alias for `Reg<R8_USB_INT_ST_SPEC>`"]
pub type R8_USB_INT_ST = crate::Reg<r8_usb_int_st::R8_USB_INT_ST_SPEC>;
#[doc = "USB interrupt status"]
pub mod r8_usb_int_st;
#[doc = "R8_USB_RX_LEN (r) register accessor: an alias for `Reg<R8_USB_RX_LEN_SPEC>`"]
pub type R8_USB_RX_LEN = crate::Reg<r8_usb_rx_len::R8_USB_RX_LEN_SPEC>;
#[doc = "USB receiving length"]
pub mod r8_usb_rx_len;
#[doc = "R8_UEP4_1_MOD (rw) register accessor: an alias for `Reg<R8_UEP4_1_MOD_SPEC>`"]
pub type R8_UEP4_1_MOD = crate::Reg<r8_uep4_1_mod::R8_UEP4_1_MOD_SPEC>;
#[doc = "endpoint 4/1 mode"]
pub mod r8_uep4_1_mod;
#[doc = "R8_UEP2_3_MOD__R8_UH_EP_MOD (rw) register accessor: an alias for `Reg<R8_UEP2_3_MOD__R8_UH_EP_MOD_SPEC>`"]
pub type R8_UEP2_3_MOD__R8_UH_EP_MOD =
    crate::Reg<r8_uep2_3_mod__r8_uh_ep_mod::R8_UEP2_3_MOD__R8_UH_EP_MOD_SPEC>;
#[doc = "endpoint 2/3 mode;host endpoint mode"]
pub mod r8_uep2_3_mod__r8_uh_ep_mod;
#[doc = "R16_UEP0_DMA (rw) register accessor: an alias for `Reg<R16_UEP0_DMA_SPEC>`"]
pub type R16_UEP0_DMA = crate::Reg<r16_uep0_dma::R16_UEP0_DMA_SPEC>;
#[doc = "endpoint 0 DMA buffer address"]
pub mod r16_uep0_dma;
#[doc = "R16_UEP1_DMA (rw) register accessor: an alias for `Reg<R16_UEP1_DMA_SPEC>`"]
pub type R16_UEP1_DMA = crate::Reg<r16_uep1_dma::R16_UEP1_DMA_SPEC>;
#[doc = "endpoint 1 DMA buffer address"]
pub mod r16_uep1_dma;
#[doc = "R16_UEP2_DMA__R16_UH_RX_DMA (rw) register accessor: an alias for `Reg<R16_UEP2_DMA__R16_UH_RX_DMA_SPEC>`"]
pub type R16_UEP2_DMA__R16_UH_RX_DMA =
    crate::Reg<r16_uep2_dma__r16_uh_rx_dma::R16_UEP2_DMA__R16_UH_RX_DMA_SPEC>;
#[doc = "endpoint 2 DMA buffer address;host rx endpoint buffer high address"]
pub mod r16_uep2_dma__r16_uh_rx_dma;
#[doc = "R16_UEP3_DMA__R16_UH_TX_DMA (rw) register accessor: an alias for `Reg<R16_UEP3_DMA__R16_UH_TX_DMA_SPEC>`"]
pub type R16_UEP3_DMA__R16_UH_TX_DMA =
    crate::Reg<r16_uep3_dma__r16_uh_tx_dma::R16_UEP3_DMA__R16_UH_TX_DMA_SPEC>;
#[doc = "endpoint 3 DMA buffer address;host tx endpoint buffer high address"]
pub mod r16_uep3_dma__r16_uh_tx_dma;
#[doc = "R8_UEP0_T_LEN (rw) register accessor: an alias for `Reg<R8_UEP0_T_LEN_SPEC>`"]
pub type R8_UEP0_T_LEN = crate::Reg<r8_uep0_t_len::R8_UEP0_T_LEN_SPEC>;
#[doc = "endpoint 0 transmittal length"]
pub mod r8_uep0_t_len;
#[doc = "R8_UEP0_CTRL (rw) register accessor: an alias for `Reg<R8_UEP0_CTRL_SPEC>`"]
pub type R8_UEP0_CTRL = crate::Reg<r8_uep0_ctrl::R8_UEP0_CTRL_SPEC>;
#[doc = "endpoint 0 control"]
pub mod r8_uep0_ctrl;
#[doc = "R8_UEP1_T_LEN (rw) register accessor: an alias for `Reg<R8_UEP1_T_LEN_SPEC>`"]
pub type R8_UEP1_T_LEN = crate::Reg<r8_uep1_t_len::R8_UEP1_T_LEN_SPEC>;
#[doc = "endpoint 1 transmittal length"]
pub mod r8_uep1_t_len;
#[doc = "R8_UEP1_CTRL__R8_UH_SETUP (rw) register accessor: an alias for `Reg<R8_UEP1_CTRL__R8_UH_SETUP_SPEC>`"]
pub type R8_UEP1_CTRL__R8_UH_SETUP =
    crate::Reg<r8_uep1_ctrl__r8_uh_setup::R8_UEP1_CTRL__R8_UH_SETUP_SPEC>;
#[doc = "endpoint 1 control;host aux setup"]
pub mod r8_uep1_ctrl__r8_uh_setup;
#[doc = "R8_UEP2_T_LEN__R8_UH_EP_PID (rw) register accessor: an alias for `Reg<R8_UEP2_T_LEN__R8_UH_EP_PID_SPEC>`"]
pub type R8_UEP2_T_LEN__R8_UH_EP_PID =
    crate::Reg<r8_uep2_t_len__r8_uh_ep_pid::R8_UEP2_T_LEN__R8_UH_EP_PID_SPEC>;
#[doc = "endpoint 2 transmittal length;host endpoint and PID"]
pub mod r8_uep2_t_len__r8_uh_ep_pid;
#[doc = "R8_UEP2_CTRL__R8_UH_RX_CTRL (rw) register accessor: an alias for `Reg<R8_UEP2_CTRL__R8_UH_RX_CTRL_SPEC>`"]
pub type R8_UEP2_CTRL__R8_UH_RX_CTRL =
    crate::Reg<r8_uep2_ctrl__r8_uh_rx_ctrl::R8_UEP2_CTRL__R8_UH_RX_CTRL_SPEC>;
#[doc = "endpoint 2 control;host receiver endpoint control"]
pub mod r8_uep2_ctrl__r8_uh_rx_ctrl;
#[doc = "R8_UEP3_T_LEN__R8_UH_TX_LEN (rw) register accessor: an alias for `Reg<R8_UEP3_T_LEN__R8_UH_TX_LEN_SPEC>`"]
pub type R8_UEP3_T_LEN__R8_UH_TX_LEN =
    crate::Reg<r8_uep3_t_len__r8_uh_tx_len::R8_UEP3_T_LEN__R8_UH_TX_LEN_SPEC>;
#[doc = "endpoint 3 transmittal length;host transmittal endpoint transmittal length"]
pub mod r8_uep3_t_len__r8_uh_tx_len;
#[doc = "R8_UEP3_CTRL__R8_UH_TX_CTRL (rw) register accessor: an alias for `Reg<R8_UEP3_CTRL__R8_UH_TX_CTRL_SPEC>`"]
pub type R8_UEP3_CTRL__R8_UH_TX_CTRL =
    crate::Reg<r8_uep3_ctrl__r8_uh_tx_ctrl::R8_UEP3_CTRL__R8_UH_TX_CTRL_SPEC>;
#[doc = "endpoint 3 control;host transmittal endpoint control"]
pub mod r8_uep3_ctrl__r8_uh_tx_ctrl;
#[doc = "R8_UEP4_T_LEN (rw) register accessor: an alias for `Reg<R8_UEP4_T_LEN_SPEC>`"]
pub type R8_UEP4_T_LEN = crate::Reg<r8_uep4_t_len::R8_UEP4_T_LEN_SPEC>;
#[doc = "endpoint 4 transmittal length"]
pub mod r8_uep4_t_len;
#[doc = "R8_UEP4_CTRL (rw) register accessor: an alias for `Reg<R8_UEP4_CTRL_SPEC>`"]
pub type R8_UEP4_CTRL = crate::Reg<r8_uep4_ctrl::R8_UEP4_CTRL_SPEC>;
#[doc = "endpoint 4 control"]
pub mod r8_uep4_ctrl;
#[doc = "R8_USB_TYPE_C_CTRL (rw) register accessor: an alias for `Reg<R8_USB_TYPE_C_CTRL_SPEC>`"]
pub type R8_USB_TYPE_C_CTRL = crate::Reg<r8_usb_type_c_ctrl::R8_USB_TYPE_C_CTRL_SPEC>;
#[doc = "USB type-C control"]
pub mod r8_usb_type_c_ctrl;
