#[doc = "Register `R8_USB_INT_EN` reader"]
pub struct R(crate::R<R8_USB_INT_EN_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_USB_INT_EN_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_USB_INT_EN_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_USB_INT_EN_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_USB_INT_EN` writer"]
pub struct W(crate::W<R8_USB_INT_EN_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_USB_INT_EN_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_USB_INT_EN_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_USB_INT_EN_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_UIE_BUS_RST__RB_UIE_DETECT` reader - enable interrupt for USB bus reset event for USB device mode;enable interrupt for USB device detected event for USB host mode"]
pub type RB_UIE_BUS_RST__RB_UIE_DETECT_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_BUS_RST__RB_UIE_DETECT` writer - enable interrupt for USB bus reset event for USB device mode;enable interrupt for USB device detected event for USB host mode"]
pub type RB_UIE_BUS_RST__RB_UIE_DETECT_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
#[doc = "Field `RB_UIE_TRANSFER` reader - enable interrupt for USB transfer completion"]
pub type RB_UIE_TRANSFER_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_TRANSFER` writer - enable interrupt for USB transfer completion"]
pub type RB_UIE_TRANSFER_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
#[doc = "Field `RB_UIE_SUSPEND` reader - enable interrupt for USB suspend or resume event"]
pub type RB_UIE_SUSPEND_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_SUSPEND` writer - enable interrupt for USB suspend or resume event"]
pub type RB_UIE_SUSPEND_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
#[doc = "Field `RB_UIE_HST_SOF` reader - enable interrupt for host SOF timer action for USB host mode"]
pub type RB_UIE_HST_SOF_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_HST_SOF` writer - enable interrupt for host SOF timer action for USB host mode"]
pub type RB_UIE_HST_SOF_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
#[doc = "Field `RB_UIE_FIFO_OV` reader - enable interrupt for FIFO overflow"]
pub type RB_UIE_FIFO_OV_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_FIFO_OV` writer - enable interrupt for FIFO overflow"]
pub type RB_UIE_FIFO_OV_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
#[doc = "Field `RB_UIE_DEV_NAK` reader - enable interrupt for NAK responded for USB device mode"]
pub type RB_UIE_DEV_NAK_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_DEV_NAK` writer - enable interrupt for NAK responded for USB device mode"]
pub type RB_UIE_DEV_NAK_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
#[doc = "Field `RB_UIE_DEV_SOF` reader - enable interrupt for SOF received for USB device mode"]
pub type RB_UIE_DEV_SOF_R = crate::BitReader<bool>;
#[doc = "Field `RB_UIE_DEV_SOF` writer - enable interrupt for SOF received for USB device mode"]
pub type RB_UIE_DEV_SOF_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_USB_INT_EN_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - enable interrupt for USB bus reset event for USB device mode;enable interrupt for USB device detected event for USB host mode"]
    #[inline(always)]
    pub fn rb_uie_bus_rst__rb_uie_detect(&self) -> RB_UIE_BUS_RST__RB_UIE_DETECT_R {
        RB_UIE_BUS_RST__RB_UIE_DETECT_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - enable interrupt for USB transfer completion"]
    #[inline(always)]
    pub fn rb_uie_transfer(&self) -> RB_UIE_TRANSFER_R {
        RB_UIE_TRANSFER_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - enable interrupt for USB suspend or resume event"]
    #[inline(always)]
    pub fn rb_uie_suspend(&self) -> RB_UIE_SUSPEND_R {
        RB_UIE_SUSPEND_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - enable interrupt for host SOF timer action for USB host mode"]
    #[inline(always)]
    pub fn rb_uie_hst_sof(&self) -> RB_UIE_HST_SOF_R {
        RB_UIE_HST_SOF_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - enable interrupt for FIFO overflow"]
    #[inline(always)]
    pub fn rb_uie_fifo_ov(&self) -> RB_UIE_FIFO_OV_R {
        RB_UIE_FIFO_OV_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 6 - enable interrupt for NAK responded for USB device mode"]
    #[inline(always)]
    pub fn rb_uie_dev_nak(&self) -> RB_UIE_DEV_NAK_R {
        RB_UIE_DEV_NAK_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - enable interrupt for SOF received for USB device mode"]
    #[inline(always)]
    pub fn rb_uie_dev_sof(&self) -> RB_UIE_DEV_SOF_R {
        RB_UIE_DEV_SOF_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - enable interrupt for USB bus reset event for USB device mode;enable interrupt for USB device detected event for USB host mode"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_bus_rst__rb_uie_detect(&mut self) -> RB_UIE_BUS_RST__RB_UIE_DETECT_W<0> {
        RB_UIE_BUS_RST__RB_UIE_DETECT_W::new(self)
    }
    #[doc = "Bit 1 - enable interrupt for USB transfer completion"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_transfer(&mut self) -> RB_UIE_TRANSFER_W<1> {
        RB_UIE_TRANSFER_W::new(self)
    }
    #[doc = "Bit 2 - enable interrupt for USB suspend or resume event"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_suspend(&mut self) -> RB_UIE_SUSPEND_W<2> {
        RB_UIE_SUSPEND_W::new(self)
    }
    #[doc = "Bit 3 - enable interrupt for host SOF timer action for USB host mode"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_hst_sof(&mut self) -> RB_UIE_HST_SOF_W<3> {
        RB_UIE_HST_SOF_W::new(self)
    }
    #[doc = "Bit 4 - enable interrupt for FIFO overflow"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_fifo_ov(&mut self) -> RB_UIE_FIFO_OV_W<4> {
        RB_UIE_FIFO_OV_W::new(self)
    }
    #[doc = "Bit 6 - enable interrupt for NAK responded for USB device mode"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_dev_nak(&mut self) -> RB_UIE_DEV_NAK_W<6> {
        RB_UIE_DEV_NAK_W::new(self)
    }
    #[doc = "Bit 7 - enable interrupt for SOF received for USB device mode"]
    #[inline(always)]
    #[must_use]
    pub fn rb_uie_dev_sof(&mut self) -> RB_UIE_DEV_SOF_W<7> {
        RB_UIE_DEV_SOF_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "USB interrupt enable\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_usb_int_en](index.html) module"]
pub struct R8_USB_INT_EN_SPEC;
impl crate::RegisterSpec for R8_USB_INT_EN_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_usb_int_en::R](R) reader structure"]
impl crate::Readable for R8_USB_INT_EN_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_usb_int_en::W](W) writer structure"]
impl crate::Writable for R8_USB_INT_EN_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_USB_INT_EN to value 0"]
impl crate::Resettable for R8_USB_INT_EN_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
