#[doc = "Register `R8_USB_TYPE_C_CTRL` reader"]
pub struct R(crate::R<R8_USB_TYPE_C_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_USB_TYPE_C_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_USB_TYPE_C_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_USB_TYPE_C_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_USB_TYPE_C_CTRL` writer"]
pub struct W(crate::W<R8_USB_TYPE_C_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_USB_TYPE_C_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_USB_TYPE_C_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_USB_TYPE_C_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_UCC1_PU_EN` reader - USB CC1 pullup resistance control"]
pub type RB_UCC1_PU_EN_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_UCC1_PU_EN` writer - USB CC1 pullup resistance control"]
pub type RB_UCC1_PU_EN_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_USB_TYPE_C_CTRL_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_UCC1_PD_EN` reader - USB CC1 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
pub type RB_UCC1_PD_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_UCC1_PD_EN` writer - USB CC1 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
pub type RB_UCC1_PD_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_USB_TYPE_C_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_VBUS_PD_EN` reader - USB VBUS 10K pulldown resistance: 0=disable, 1=enable pullup"]
pub type RB_VBUS_PD_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_VBUS_PD_EN` writer - USB VBUS 10K pulldown resistance: 0=disable, 1=enable pullup"]
pub type RB_VBUS_PD_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_USB_TYPE_C_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UCC2_PU_EN` reader - USB CC2 pullup resistance control"]
pub type RB_UCC2_PU_EN_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_UCC2_PU_EN` writer - USB CC2 pullup resistance control"]
pub type RB_UCC2_PU_EN_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_USB_TYPE_C_CTRL_SPEC, u8, u8, 2, O>;
#[doc = "Field `RB_UCC2_PD_EN` reader - USB CC2 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
pub type RB_UCC2_PD_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_UCC2_PD_EN` writer - USB CC2 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
pub type RB_UCC2_PD_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_USB_TYPE_C_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UTCC_GP_BIT` reader - USB general purpose bit"]
pub type RB_UTCC_GP_BIT_R = crate::BitReader<bool>;
#[doc = "Field `RB_UTCC_GP_BIT` writer - USB general purpose bit"]
pub type RB_UTCC_GP_BIT_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_USB_TYPE_C_CTRL_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:1 - USB CC1 pullup resistance control"]
    #[inline(always)]
    pub fn rb_ucc1_pu_en(&self) -> RB_UCC1_PU_EN_R {
        RB_UCC1_PU_EN_R::new(self.bits & 3)
    }
    #[doc = "Bit 2 - USB CC1 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
    #[inline(always)]
    pub fn rb_ucc1_pd_en(&self) -> RB_UCC1_PD_EN_R {
        RB_UCC1_PD_EN_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - USB VBUS 10K pulldown resistance: 0=disable, 1=enable pullup"]
    #[inline(always)]
    pub fn rb_vbus_pd_en(&self) -> RB_VBUS_PD_EN_R {
        RB_VBUS_PD_EN_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bits 4:5 - USB CC2 pullup resistance control"]
    #[inline(always)]
    pub fn rb_ucc2_pu_en(&self) -> RB_UCC2_PU_EN_R {
        RB_UCC2_PU_EN_R::new((self.bits >> 4) & 3)
    }
    #[doc = "Bit 6 - USB CC2 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
    #[inline(always)]
    pub fn rb_ucc2_pd_en(&self) -> RB_UCC2_PD_EN_R {
        RB_UCC2_PD_EN_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - USB general purpose bit"]
    #[inline(always)]
    pub fn rb_utcc_gp_bit(&self) -> RB_UTCC_GP_BIT_R {
        RB_UTCC_GP_BIT_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - USB CC1 pullup resistance control"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ucc1_pu_en(&mut self) -> RB_UCC1_PU_EN_W<0> {
        RB_UCC1_PU_EN_W::new(self)
    }
    #[doc = "Bit 2 - USB CC1 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ucc1_pd_en(&mut self) -> RB_UCC1_PD_EN_W<2> {
        RB_UCC1_PD_EN_W::new(self)
    }
    #[doc = "Bit 3 - USB VBUS 10K pulldown resistance: 0=disable, 1=enable pullup"]
    #[inline(always)]
    #[must_use]
    pub fn rb_vbus_pd_en(&mut self) -> RB_VBUS_PD_EN_W<3> {
        RB_VBUS_PD_EN_W::new(self)
    }
    #[doc = "Bits 4:5 - USB CC2 pullup resistance control"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ucc2_pu_en(&mut self) -> RB_UCC2_PU_EN_W<4> {
        RB_UCC2_PU_EN_W::new(self)
    }
    #[doc = "Bit 6 - USB CC2 5.1K pulldown resistance: 0=disable, 1=enable pulldown"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ucc2_pd_en(&mut self) -> RB_UCC2_PD_EN_W<6> {
        RB_UCC2_PD_EN_W::new(self)
    }
    #[doc = "Bit 7 - USB general purpose bit"]
    #[inline(always)]
    #[must_use]
    pub fn rb_utcc_gp_bit(&mut self) -> RB_UTCC_GP_BIT_W<7> {
        RB_UTCC_GP_BIT_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "USB type-C control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_usb_type_c_ctrl](index.html) module"]
pub struct R8_USB_TYPE_C_CTRL_SPEC;
impl crate::RegisterSpec for R8_USB_TYPE_C_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_usb_type_c_ctrl::R](R) reader structure"]
impl crate::Readable for R8_USB_TYPE_C_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_usb_type_c_ctrl::W](W) writer structure"]
impl crate::Writable for R8_USB_TYPE_C_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_USB_TYPE_C_CTRL to value 0"]
impl crate::Resettable for R8_USB_TYPE_C_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
